// 
// Decompiled by Procyon v0.5.36
// 

package me.razerboy420.weepcraft.util;

import java.util.Random;
import java.security.NoSuchAlgorithmException;
import java.nio.charset.Charset;
import java.security.MessageDigest;
import javax.crypto.spec.SecretKeySpec;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.KeySpec;
import java.math.BigInteger;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.nio.file.Files;
import java.nio.file.OpenOption;
import javax.crypto.KeyGenerator;
import java.security.spec.RSAPrivateKeySpec;
import java.security.KeyFactory;
import java.security.spec.RSAPublicKeySpec;
import java.io.OutputStream;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.security.KeyPairGenerator;
import net.minecraft.client.Minecraft;
import java.util.Base64;
import java.security.spec.AlgorithmParameterSpec;
import java.security.Key;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.Cipher;
import me.razerboy420.weepcraft.Weepcraft;
import java.security.SecureRandom;
import javax.crypto.SecretKey;
import java.security.KeyPair;
import java.io.File;

public class Encryption
{
    public static final String CHARSET = "UTF-8";
    private static final File rsaKeyDir;
    private static final File privateFile;
    private static final File publicFile;
    private static final File aesFile;
    private static KeyPair keypair;
    private static SecretKey aesKey;
    private static final SecureRandom random;
    
    static {
        rsaKeyDir = ((System.getProperty("user.home") != null) ? new File(System.getProperty("user.home"), ".ssh") : null);
        privateFile = ((Encryption.rsaKeyDir != null) ? new File(Encryption.rsaKeyDir, "weep_rsa") : null);
        publicFile = ((Encryption.rsaKeyDir != null) ? new File(Encryption.rsaKeyDir, "weep_rsa.pub") : null);
        aesFile = new File(Weepcraft.weepcraftDir, "key");
        random = new SecureRandom();
    }
    
    public static String encrypt(final String string) {
        checkKeys();
        try {
            final Cipher cipher = Cipher.getInstance("AES/CFB8/NoPadding");
            cipher.init(1, Encryption.aesKey, new IvParameterSpec(Encryption.aesKey.getEncoded()));
            return Base64.getEncoder().encodeToString(cipher.doFinal(string.getBytes("UTF-8")));
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String decrypt(final String string) {
        checkKeys();
        try {
            final Cipher cipher = Cipher.getInstance("AES/CFB8/NoPadding");
            cipher.init(2, Encryption.aesKey, new IvParameterSpec(Encryption.aesKey.getEncoded()));
            return new String(cipher.doFinal(Base64.getDecoder().decode(string)), "UTF-8");
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    private static void checkKeys() {
        if (hasKeys()) {
            return;
        }
        if (Encryption.rsaKeyDir == null) {
            System.err.println("RSA key dir does not exist!");
            Minecraft.getMinecraft().shutdown();
            return;
        }
        if (hasRsaKeyFiles() && loadRsaKeys()) {
            if (hasAesKeyFile() && loadAesKey()) {
                return;
            }
            regenerateAesKey();
        }
        else {
            regenerateRsaKeys();
            regenerateAesKey();
        }
    }
    
    private static boolean hasRsaKeyFiles() {
        return Encryption.privateFile.exists() && Encryption.publicFile.exists();
    }
    
    private static boolean hasAesKeyFile() {
        return Encryption.aesFile.exists();
    }
    
    private static boolean hasKeys() {
        return Encryption.keypair != null && Encryption.keypair.getPrivate().getEncoded() != null && Encryption.keypair.getPublic().getEncoded() != null && Encryption.aesKey != null && Encryption.aesKey.getEncoded() != null;
    }
    
    private static void regenerateRsaKeys() {
        System.out.println("WARNING: Regenerating RSA keys!");
        try {
            final KeyPairGenerator keypairgen = KeyPairGenerator.getInstance("RSA");
            keypairgen.initialize(1024);
            Encryption.keypair = keypairgen.generateKeyPair();
            if (!Encryption.publicFile.getParentFile().exists()) {
                Encryption.publicFile.getParentFile().mkdirs();
            }
            final ObjectOutputStream savePublic = new ObjectOutputStream(new FileOutputStream(Encryption.publicFile));
            savePublic.writeObject(KeyFactory.getInstance("RSA").getKeySpec(Encryption.keypair.getPublic(), RSAPublicKeySpec.class).getModulus());
            savePublic.writeObject(KeyFactory.getInstance("RSA").getKeySpec(Encryption.keypair.getPublic(), RSAPublicKeySpec.class).getPublicExponent());
            savePublic.close();
            if (!Encryption.privateFile.getParentFile().exists()) {
                Encryption.privateFile.getParentFile().mkdirs();
            }
            final ObjectOutputStream savePrivate = new ObjectOutputStream(new FileOutputStream(Encryption.privateFile));
            savePrivate.writeObject(KeyFactory.getInstance("RSA").getKeySpec(Encryption.keypair.getPrivate(), RSAPrivateKeySpec.class).getModulus());
            savePrivate.writeObject(KeyFactory.getInstance("RSA").getKeySpec(Encryption.keypair.getPrivate(), RSAPrivateKeySpec.class).getPrivateExponent());
            savePrivate.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private static void regenerateAesKey() {
        System.out.println("WARNING: Regenerating AES key!");
        try {
            final KeyGenerator keygen = KeyGenerator.getInstance("AES");
            keygen.init(128);
            Encryption.aesKey = keygen.generateKey();
            if (!Encryption.aesFile.getParentFile().exists()) {
                Encryption.aesFile.getParentFile().mkdirs();
            }
            final Cipher rsaCipher = Cipher.getInstance("RSA");
            rsaCipher.init(1, Encryption.keypair.getPublic());
            Files.write(Encryption.aesFile.toPath(), rsaCipher.doFinal(Encryption.aesKey.getEncoded()), new OpenOption[0]);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private static boolean loadRsaKeys() {
        try {
            final ObjectInputStream publicLoad = new ObjectInputStream(new FileInputStream(Encryption.publicFile));
            final PublicKey loadedPublicKey = KeyFactory.getInstance("RSA").generatePublic(new RSAPublicKeySpec((BigInteger)publicLoad.readObject(), (BigInteger)publicLoad.readObject()));
            publicLoad.close();
            final ObjectInputStream privateLoad = new ObjectInputStream(new FileInputStream(Encryption.privateFile));
            final PrivateKey loadedPrivateKey = KeyFactory.getInstance("RSA").generatePrivate(new RSAPrivateKeySpec((BigInteger)privateLoad.readObject(), (BigInteger)privateLoad.readObject()));
            privateLoad.close();
            Encryption.keypair = new KeyPair(loadedPublicKey, loadedPrivateKey);
            return true;
        }
        catch (Exception e) {
            System.err.println("Failed to load RSA keys!");
            e.printStackTrace();
            return false;
        }
    }
    
    private static boolean loadAesKey() {
        try {
            final Cipher rsaCipher = Cipher.getInstance("RSA");
            rsaCipher.init(2, Encryption.keypair.getPrivate());
            Encryption.aesKey = new SecretKeySpec(rsaCipher.doFinal(Files.readAllBytes(Encryption.aesFile.toPath())), "AES");
            return true;
        }
        catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }
    
    public static String sha256(final String s) {
        try {
            final MessageDigest mDigest = MessageDigest.getInstance("SHA-256");
            final byte[] shaByteArr = mDigest.digest(s.getBytes(Charset.forName("UTF-8")));
            final StringBuilder hexStrBuilder = new StringBuilder();
            for (final byte element : shaByteArr) {
                hexStrBuilder.append(String.format("%02x", element));
            }
            return hexStrBuilder.toString();
        }
        catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            return "";
        }
    }
    
    public static String nextRandomString() {
        return new BigInteger(130, Encryption.random).toString(32);
    }
    
    public static final String md5(final String toEncrypt) {
        try {
            final MessageDigest digest = MessageDigest.getInstance("md5");
            digest.update(toEncrypt.getBytes());
            final byte[] bytes = digest.digest();
            final StringBuilder sb = new StringBuilder();
            for (int i = 0; i < bytes.length; ++i) {
                sb.append(String.format("%02X", bytes[i]));
            }
            return sb.toString().toLowerCase();
        }
        catch (Exception exc) {
            return "";
        }
    }
}
