// 
// Decompiled by Procyon v0.5.36
// 

package me.razerboy420.weepcraft.util;

import java.nio.FloatBuffer;
import org.lwjgl.BufferUtils;
import net.minecraft.client.gui.ScaledResolution;
import org.lwjgl.opengl.GL13;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.ARBShaderObjects;
import net.minecraft.client.Minecraft;
import net.minecraft.client.shader.Framebuffer;

public class ShaderUtil
{
    Framebuffer entityFBO;
    Framebuffer overlayFBO;
    public int shaderProgramID;
    public int vertexShaderID;
    public int fragmentShaderID;
    public int diffuseSamperUniformID;
    public int texelSizeUniformID;
    
    public ShaderUtil() {
        this.entityFBO = new Framebuffer(Minecraft.getMinecraft().displayWidth, Minecraft.getMinecraft().displayHeight, false);
        this.overlayFBO = new Framebuffer(Minecraft.getMinecraft().displayWidth, Minecraft.getMinecraft().displayHeight, false);
        this.shaderProgramID = -1;
        this.vertexShaderID = -1;
        this.fragmentShaderID = -1;
        this.diffuseSamperUniformID = -1;
        this.texelSizeUniformID = -1;
    }
    
    private int createShader(final String shaderCode, final int shaderType) throws Exception {
        int shader = 0;
        try {
            shader = ARBShaderObjects.glCreateShaderObjectARB(shaderType);
            if (shader == 0) {
                return 0;
            }
        }
        catch (Exception exc) {
            ARBShaderObjects.glDeleteObjectARB(shader);
            throw exc;
        }
        ARBShaderObjects.glShaderSourceARB(shader, (CharSequence)shaderCode);
        ARBShaderObjects.glCompileShaderARB(shader);
        if (ARBShaderObjects.glGetObjectParameteriARB(shader, 35713) == 0) {
            throw new RuntimeException("Error creating shader: " + getLogInfo(shader));
        }
        return shader;
    }
    
    public void s() {
        if (this.shaderProgramID == -1) {
            this.shaderProgramID = ARBShaderObjects.glCreateProgramObjectARB();
            try {
                if (this.vertexShaderID == -1) {
                    final String vertexShaderCode = "#version 120 \nvoid main() { \ngl_TexCoord[0] = gl_MultiTexCoord0; \ngl_Position = gl_ModelViewProjectionMatrix * gl_Vertex; \n}";
                    this.vertexShaderID = this.createShader(vertexShaderCode, 35633);
                }
                if (this.fragmentShaderID == -1) {
                    final String fragmentShaderCode = "#version 120 \nuniform sampler2D DiffuseSamper; \nuniform vec2 TexelSize; \nvoid main(){ \nvec4 centerCol = texture2D(DiffuseSamper, gl_TexCoord[0].st); \nif(centerCol.r == 1.0f && centerCol.g == 1.0f && centerCol.b == 1.0f) { \ngl_FragColor = vec4(0, 0, 0, 0); \nreturn; \n} \nvec4 colAvg = vec4(0, 0, 0, 0); \nfor(int xo = -7; xo < 7; xo++) { \nfor(int yo = -7; yo < 7; yo++) { \nvec4 currCol = texture2D(DiffuseSamper, gl_TexCoord[0].st + vec2(xo * TexelSize.x, yo * TexelSize.y)); \nif(currCol.r != 0.0F || currCol.g != 0.0F || currCol.b != 0.0F) { \ncolAvg += vec4(1, 0, 0, max(0, (6.0f - sqrt(xo*xo*1.0f + yo*yo*1.0f)) / 2.0F)); \n} \n} \n} \ncolAvg.a /= 64.0F; \ngl_FragColor = colAvg; \n}";
                    this.fragmentShaderID = this.createShader(fragmentShaderCode, 35632);
                }
            }
            catch (Exception ex) {
                this.shaderProgramID = -1;
                this.vertexShaderID = -1;
                this.fragmentShaderID = -1;
                ex.printStackTrace();
            }
            if (this.shaderProgramID != -1) {
                ARBShaderObjects.glAttachObjectARB(this.shaderProgramID, this.vertexShaderID);
                ARBShaderObjects.glAttachObjectARB(this.shaderProgramID, this.fragmentShaderID);
                ARBShaderObjects.glLinkProgramARB(this.shaderProgramID);
                if (ARBShaderObjects.glGetObjectParameteriARB(this.shaderProgramID, 35714) == 0) {
                    System.err.println(getLogInfo(this.shaderProgramID));
                    return;
                }
                ARBShaderObjects.glValidateProgramARB(this.shaderProgramID);
                if (ARBShaderObjects.glGetObjectParameteriARB(this.shaderProgramID, 35715) == 0) {
                    System.err.println(getLogInfo(this.shaderProgramID));
                    return;
                }
                ARBShaderObjects.glUseProgramObjectARB(0);
                this.diffuseSamperUniformID = ARBShaderObjects.glGetUniformLocationARB(this.shaderProgramID, (CharSequence)"DiffuseSamper");
                this.texelSizeUniformID = ARBShaderObjects.glGetUniformLocationARB(this.shaderProgramID, (CharSequence)"TexelSize");
            }
        }
    }
    
    public void clear() {
        this.overlayFBO.bindFramebuffer(false);
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
        GL11.glClear(16640);
        this.entityFBO.bindFramebuffer(false);
        GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
        GL11.glClear(16640);
    }
    
    public void bind(final int shaderProgramID) {
        ARBShaderObjects.glUseProgramObjectARB(shaderProgramID);
    }
    
    public void upload() {
        ARBShaderObjects.glUniform1iARB(this.diffuseSamperUniformID, 0);
        GL13.glActiveTexture(33984);
        GL11.glEnable(3553);
        this.entityFBO.bindFramebufferTexture();
    }
    
    public void uploadTexel() {
        final ScaledResolution sr = new ScaledResolution(Minecraft.getMinecraft());
        final FloatBuffer texelSizeBuffer = BufferUtils.createFloatBuffer(2);
        texelSizeBuffer.position(0);
        texelSizeBuffer.put(1.0f / sr.getScaledWidth());
        texelSizeBuffer.put(1.0f / sr.getScaledHeight());
        texelSizeBuffer.flip();
        ARBShaderObjects.glUniform2ARB(this.texelSizeUniformID, texelSizeBuffer);
    }
    
    private static String getLogInfo(final int obj) {
        return ARBShaderObjects.glGetInfoLogARB(obj, ARBShaderObjects.glGetObjectParameteriARB(obj, 35716));
    }
}
