// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.block;

import net.minecraft.util.math.Vec3i;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.util.Mirror;
import net.minecraft.util.Rotation;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.EnumHand;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.CommandBlockBaseLogic;
import net.minecraft.util.StringUtils;
import java.util.Random;
import net.minecraft.util.math.BlockPos;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntityCommandBlock;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import net.minecraft.block.properties.IProperty;
import net.minecraft.util.EnumFacing;
import net.minecraft.block.material.Material;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyDirection;

public class BlockCommandBlock extends BlockContainer
{
    public static final PropertyDirection FACING;
    public static final PropertyBool CONDITIONAL;
    
    static {
        FACING = BlockDirectional.FACING;
        CONDITIONAL = PropertyBool.create("conditional");
    }
    
    public BlockCommandBlock(final MapColor color) {
        super(Material.IRON, color);
        this.setDefaultState(this.blockState.getBaseState().withProperty((IProperty<Comparable>)BlockCommandBlock.FACING, EnumFacing.NORTH).withProperty((IProperty<Comparable>)BlockCommandBlock.CONDITIONAL, false));
    }
    
    @Override
    public TileEntity createNewTileEntity(final World worldIn, final int meta) {
        final TileEntityCommandBlock tileentitycommandblock = new TileEntityCommandBlock();
        tileentitycommandblock.setAuto(this == Blocks.CHAIN_COMMAND_BLOCK);
        return tileentitycommandblock;
    }
    
    @Override
    public void neighborChanged(final IBlockState state, final World worldIn, final BlockPos pos, final Block blockIn, final BlockPos p_189540_5_) {
        if (!worldIn.isRemote) {
            final TileEntity tileentity = worldIn.getTileEntity(pos);
            if (tileentity instanceof TileEntityCommandBlock) {
                final TileEntityCommandBlock tileentitycommandblock = (TileEntityCommandBlock)tileentity;
                final boolean flag = worldIn.isBlockPowered(pos);
                final boolean flag2 = tileentitycommandblock.isPowered();
                final boolean flag3 = tileentitycommandblock.isAuto();
                if (flag && !flag2) {
                    tileentitycommandblock.setPowered(true);
                    if (tileentitycommandblock.getMode() != TileEntityCommandBlock.Mode.SEQUENCE && !flag3) {
                        final boolean flag4 = !tileentitycommandblock.isConditional() || this.isNextToSuccessfulCommandBlock(worldIn, pos, state);
                        tileentitycommandblock.setConditionMet(flag4);
                        worldIn.scheduleUpdate(pos, this, this.tickRate(worldIn));
                        if (flag4) {
                            this.propagateUpdate(worldIn, pos);
                        }
                    }
                }
                else if (!flag && flag2) {
                    tileentitycommandblock.setPowered(false);
                }
            }
        }
    }
    
    @Override
    public void updateTick(final World worldIn, final BlockPos pos, final IBlockState state, final Random rand) {
        if (!worldIn.isRemote) {
            final TileEntity tileentity = worldIn.getTileEntity(pos);
            if (tileentity instanceof TileEntityCommandBlock) {
                final TileEntityCommandBlock tileentitycommandblock = (TileEntityCommandBlock)tileentity;
                final CommandBlockBaseLogic commandblockbaselogic = tileentitycommandblock.getCommandBlockLogic();
                final boolean flag = !StringUtils.isNullOrEmpty(commandblockbaselogic.getCommand());
                final TileEntityCommandBlock.Mode tileentitycommandblock$mode = tileentitycommandblock.getMode();
                final boolean flag2 = !tileentitycommandblock.isConditional() || this.isNextToSuccessfulCommandBlock(worldIn, pos, state);
                final boolean flag3 = tileentitycommandblock.isConditionMet();
                boolean flag4 = false;
                if (tileentitycommandblock$mode != TileEntityCommandBlock.Mode.SEQUENCE && flag3 && flag) {
                    commandblockbaselogic.trigger(worldIn);
                    flag4 = true;
                }
                if (tileentitycommandblock.isPowered() || tileentitycommandblock.isAuto()) {
                    if (tileentitycommandblock$mode == TileEntityCommandBlock.Mode.SEQUENCE && flag2 && flag) {
                        commandblockbaselogic.trigger(worldIn);
                        flag4 = true;
                    }
                    if (tileentitycommandblock$mode == TileEntityCommandBlock.Mode.AUTO) {
                        worldIn.scheduleUpdate(pos, this, this.tickRate(worldIn));
                        if (flag2) {
                            this.propagateUpdate(worldIn, pos);
                        }
                    }
                }
                if (!flag4) {
                    commandblockbaselogic.setSuccessCount(0);
                }
                tileentitycommandblock.setConditionMet(flag2);
                worldIn.updateComparatorOutputLevel(pos, this);
            }
        }
    }
    
    public boolean isNextToSuccessfulCommandBlock(final World worldIn, final BlockPos pos, final IBlockState state) {
        final EnumFacing enumfacing = state.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING);
        final TileEntity tileentity = worldIn.getTileEntity(pos.offset(enumfacing.getOpposite()));
        return tileentity instanceof TileEntityCommandBlock && ((TileEntityCommandBlock)tileentity).getCommandBlockLogic().getSuccessCount() > 0;
    }
    
    @Override
    public int tickRate(final World worldIn) {
        return 1;
    }
    
    @Override
    public boolean onBlockActivated(final World worldIn, final BlockPos pos, final IBlockState state, final EntityPlayer playerIn, final EnumHand hand, final EnumFacing heldItem, final float side, final float hitX, final float hitY) {
        final TileEntity tileentity = worldIn.getTileEntity(pos);
        if (tileentity instanceof TileEntityCommandBlock && playerIn.canUseCommandBlock()) {
            playerIn.displayGuiCommandBlock((TileEntityCommandBlock)tileentity);
            return true;
        }
        return false;
    }
    
    @Override
    public boolean hasComparatorInputOverride(final IBlockState state) {
        return true;
    }
    
    @Override
    public int getComparatorInputOverride(final IBlockState blockState, final World worldIn, final BlockPos pos) {
        final TileEntity tileentity = worldIn.getTileEntity(pos);
        return (tileentity instanceof TileEntityCommandBlock) ? ((TileEntityCommandBlock)tileentity).getCommandBlockLogic().getSuccessCount() : 0;
    }
    
    @Override
    public void onBlockPlacedBy(final World worldIn, final BlockPos pos, final IBlockState state, final EntityLivingBase placer, final ItemStack stack) {
        final TileEntity tileentity = worldIn.getTileEntity(pos);
        if (tileentity instanceof TileEntityCommandBlock) {
            final TileEntityCommandBlock tileentitycommandblock = (TileEntityCommandBlock)tileentity;
            final CommandBlockBaseLogic commandblockbaselogic = tileentitycommandblock.getCommandBlockLogic();
            if (stack.hasDisplayName()) {
                commandblockbaselogic.setName(stack.getDisplayName());
            }
            if (!worldIn.isRemote) {
                final NBTTagCompound nbttagcompound = stack.getTagCompound();
                if (nbttagcompound == null || !nbttagcompound.hasKey("BlockEntityTag", 10)) {
                    commandblockbaselogic.setTrackOutput(worldIn.getGameRules().getBoolean("sendCommandFeedback"));
                    tileentitycommandblock.setAuto(this == Blocks.CHAIN_COMMAND_BLOCK);
                }
                if (tileentitycommandblock.getMode() == TileEntityCommandBlock.Mode.SEQUENCE) {
                    final boolean flag = worldIn.isBlockPowered(pos);
                    tileentitycommandblock.setPowered(flag);
                }
            }
        }
    }
    
    @Override
    public int quantityDropped(final Random random) {
        return 0;
    }
    
    @Override
    public EnumBlockRenderType getRenderType(final IBlockState state) {
        return EnumBlockRenderType.MODEL;
    }
    
    @Override
    public IBlockState getStateFromMeta(final int meta) {
        return this.getDefaultState().withProperty((IProperty<Comparable>)BlockCommandBlock.FACING, EnumFacing.getFront(meta & 0x7)).withProperty((IProperty<Comparable>)BlockCommandBlock.CONDITIONAL, (meta & 0x8) != 0x0);
    }
    
    @Override
    public int getMetaFromState(final IBlockState state) {
        return state.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING).getIndex() | (state.getValue((IProperty<Boolean>)BlockCommandBlock.CONDITIONAL) ? 8 : 0);
    }
    
    @Override
    public IBlockState withRotation(final IBlockState state, final Rotation rot) {
        return state.withProperty((IProperty<Comparable>)BlockCommandBlock.FACING, rot.rotate(state.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING)));
    }
    
    @Override
    public IBlockState withMirror(final IBlockState state, final Mirror mirrorIn) {
        return state.withRotation(mirrorIn.toRotation(state.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING)));
    }
    
    @Override
    protected BlockStateContainer createBlockState() {
        return new BlockStateContainer(this, (IProperty<?>[])new IProperty[] { BlockCommandBlock.FACING, BlockCommandBlock.CONDITIONAL });
    }
    
    @Override
    public IBlockState onBlockPlaced(final World worldIn, final BlockPos pos, final EnumFacing facing, final float hitX, final float hitY, final float hitZ, final int meta, final EntityLivingBase placer) {
        return this.getDefaultState().withProperty((IProperty<Comparable>)BlockCommandBlock.FACING, EnumFacing.func_190914_a(pos, placer)).withProperty((IProperty<Comparable>)BlockCommandBlock.CONDITIONAL, false);
    }
    
    public void propagateUpdate(final World worldIn, final BlockPos pos) {
        final IBlockState iblockstate = worldIn.getBlockState(pos);
        if (iblockstate.getBlock() == Blocks.COMMAND_BLOCK || iblockstate.getBlock() == Blocks.REPEATING_COMMAND_BLOCK) {
            final BlockPos.MutableBlockPos blockpos$mutableblockpos = new BlockPos.MutableBlockPos(pos);
            blockpos$mutableblockpos.move(iblockstate.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING));
            for (TileEntity tileentity = worldIn.getTileEntity(blockpos$mutableblockpos); tileentity instanceof TileEntityCommandBlock; tileentity = worldIn.getTileEntity(blockpos$mutableblockpos)) {
                final TileEntityCommandBlock tileentitycommandblock = (TileEntityCommandBlock)tileentity;
                if (tileentitycommandblock.getMode() != TileEntityCommandBlock.Mode.SEQUENCE) {
                    break;
                }
                final IBlockState iblockstate2 = worldIn.getBlockState(blockpos$mutableblockpos);
                final Block block = iblockstate2.getBlock();
                if (block != Blocks.CHAIN_COMMAND_BLOCK) {
                    break;
                }
                if (worldIn.isUpdateScheduled(blockpos$mutableblockpos, block)) {
                    break;
                }
                worldIn.scheduleUpdate(new BlockPos(blockpos$mutableblockpos), block, this.tickRate(worldIn));
                blockpos$mutableblockpos.move(iblockstate2.getValue((IProperty<EnumFacing>)BlockCommandBlock.FACING));
            }
        }
    }
}
