// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.client.gui;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.VertexBuffer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.client.renderer.Tessellator;
import java.io.InputStream;
import net.minecraft.client.resources.IResource;
import java.io.Closeable;
import org.apache.commons.io.IOUtils;
import java.util.Collection;
import java.util.Random;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import org.apache.commons.io.Charsets;
import net.minecraft.util.text.TextFormatting;
import com.google.common.collect.Lists;
import net.minecraft.network.Packet;
import net.minecraft.network.play.client.CPacketClientStatus;
import java.io.IOException;
import net.minecraft.client.audio.SoundHandler;
import net.minecraft.client.audio.MusicTicker;
import org.apache.logging.log4j.LogManager;
import java.util.List;
import net.minecraft.util.ResourceLocation;
import org.apache.logging.log4j.Logger;

public class GuiWinGame extends GuiScreen
{
    private static final Logger LOGGER;
    private static final ResourceLocation MINECRAFT_LOGO;
    private static final ResourceLocation VIGNETTE_TEXTURE;
    private int time;
    private List<String> lines;
    private int totalScrollLength;
    private final float scrollSpeed = 0.5f;
    
    static {
        LOGGER = LogManager.getLogger();
        MINECRAFT_LOGO = new ResourceLocation("textures/gui/title/minecraft.png");
        VIGNETTE_TEXTURE = new ResourceLocation("textures/misc/vignette.png");
    }
    
    @Override
    public void updateScreen() {
        final MusicTicker musicticker = this.mc.getMusicTicker();
        final SoundHandler soundhandler = this.mc.getSoundHandler();
        if (this.time == 0) {
            musicticker.stopMusic();
            musicticker.playMusic(MusicTicker.MusicType.CREDITS);
            soundhandler.resumeSounds();
        }
        soundhandler.update();
        ++this.time;
        final float f = (this.totalScrollLength + this.height + this.height + 24) / 0.5f;
        if (this.time > f) {
            this.sendRespawnPacket();
        }
    }
    
    @Override
    protected void keyTyped(final char typedChar, final int keyCode) throws IOException {
        if (keyCode == 1) {
            this.sendRespawnPacket();
        }
    }
    
    private void sendRespawnPacket() {
        this.mc.player.connection.sendPacket(new CPacketClientStatus(CPacketClientStatus.State.PERFORM_RESPAWN));
        this.mc.displayGuiScreen(null);
    }
    
    @Override
    public boolean doesGuiPauseGame() {
        return true;
    }
    
    @Override
    public void initGui() {
        if (this.lines == null) {
            this.lines = (List<String>)Lists.newArrayList();
            IResource iresource = null;
            try {
                final String s = new StringBuilder().append(TextFormatting.WHITE).append(TextFormatting.OBFUSCATED).append(TextFormatting.GREEN).append(TextFormatting.AQUA).toString();
                final int i = 274;
                iresource = this.mc.getResourceManager().getResource(new ResourceLocation("texts/end.txt"));
                InputStream inputstream = iresource.getInputStream();
                BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(inputstream, Charsets.UTF_8));
                final Random random = new Random(8124371L);
                String s2;
                while ((s2 = bufferedreader.readLine()) != null) {
                    String s3;
                    String s4;
                    for (s2 = s2.replaceAll("PLAYERNAME", this.mc.getSession().getUsername()); s2.contains(s); s2 = String.valueOf(s3) + TextFormatting.WHITE + TextFormatting.OBFUSCATED + "XXXXXXXX".substring(0, random.nextInt(4) + 3) + s4) {
                        final int j = s2.indexOf(s);
                        s3 = s2.substring(0, j);
                        s4 = s2.substring(j + s.length());
                    }
                    this.lines.addAll(this.mc.fontRendererObj.listFormattedStringToWidth(s2, 274));
                    this.lines.add("");
                }
                inputstream.close();
                for (int k = 0; k < 8; ++k) {
                    this.lines.add("");
                }
                inputstream = this.mc.getResourceManager().getResource(new ResourceLocation("texts/credits.txt")).getInputStream();
                bufferedreader = new BufferedReader(new InputStreamReader(inputstream, Charsets.UTF_8));
                while ((s2 = bufferedreader.readLine()) != null) {
                    s2 = s2.replaceAll("PLAYERNAME", this.mc.getSession().getUsername());
                    s2 = s2.replaceAll("\t", "    ");
                    this.lines.addAll(this.mc.fontRendererObj.listFormattedStringToWidth(s2, 274));
                    this.lines.add("");
                }
                inputstream.close();
                this.totalScrollLength = this.lines.size() * 12;
            }
            catch (Exception exception) {
                GuiWinGame.LOGGER.error("Couldn't load credits", (Throwable)exception);
                return;
            }
            finally {
                IOUtils.closeQuietly((Closeable)iresource);
            }
            IOUtils.closeQuietly((Closeable)iresource);
        }
    }
    
    private void drawWinGameScreen(final int p_146575_1_, final int p_146575_2_, final float p_146575_3_) {
        final Tessellator tessellator = Tessellator.getInstance();
        final VertexBuffer vertexbuffer = tessellator.getBuffer();
        this.mc.getTextureManager().bindTexture(Gui.OPTIONS_BACKGROUND);
        vertexbuffer.begin(7, DefaultVertexFormats.POSITION_TEX_COLOR);
        final int i = this.width;
        final float f = 0.0f - (this.time + p_146575_3_) * 0.5f * 0.5f;
        final float f2 = this.height - (this.time + p_146575_3_) * 0.5f * 0.5f;
        final float f3 = 0.015625f;
        float f4 = (this.time + p_146575_3_ - 0.0f) * 0.02f;
        final float f5 = (this.totalScrollLength + this.height + this.height + 24) / 0.5f;
        final float f6 = (f5 - 20.0f - (this.time + p_146575_3_)) * 0.005f;
        if (f6 < f4) {
            f4 = f6;
        }
        if (f4 > 1.0f) {
            f4 = 1.0f;
        }
        f4 *= f4;
        f4 = f4 * 96.0f / 255.0f;
        vertexbuffer.pos(0.0, this.height, this.zLevel).tex(0.0, f * 0.015625f).color(f4, f4, f4, 1.0f).endVertex();
        vertexbuffer.pos(i, this.height, this.zLevel).tex(i * 0.015625f, f * 0.015625f).color(f4, f4, f4, 1.0f).endVertex();
        vertexbuffer.pos(i, 0.0, this.zLevel).tex(i * 0.015625f, f2 * 0.015625f).color(f4, f4, f4, 1.0f).endVertex();
        vertexbuffer.pos(0.0, 0.0, this.zLevel).tex(0.0, f2 * 0.015625f).color(f4, f4, f4, 1.0f).endVertex();
        tessellator.draw();
    }
    
    @Override
    public void drawScreen(final int mouseX, final int mouseY, final float partialTicks) {
        this.drawWinGameScreen(mouseX, mouseY, partialTicks);
        final Tessellator tessellator = Tessellator.getInstance();
        final VertexBuffer vertexbuffer = tessellator.getBuffer();
        final int i = 274;
        final int j = this.width / 2 - 137;
        final int k = this.height + 50;
        final float f = -(this.time + partialTicks) * 0.5f;
        GlStateManager.pushMatrix();
        GlStateManager.translate(0.0f, f, 0.0f);
        this.mc.getTextureManager().bindTexture(GuiWinGame.MINECRAFT_LOGO);
        GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
        this.drawTexturedModalRect(j, k, 0, 0, 155, 44);
        this.drawTexturedModalRect(j + 155, k, 0, 45, 155, 44);
        int l = k + 200;
        for (int i2 = 0; i2 < this.lines.size(); ++i2) {
            if (i2 == this.lines.size() - 1) {
                final float f2 = l + f - (this.height / 2 - 6);
                if (f2 < 0.0f) {
                    GlStateManager.translate(0.0f, -f2, 0.0f);
                }
            }
            if (l + f + 12.0f + 8.0f > 0.0f && l + f < this.height) {
                final String s = this.lines.get(i2);
                if (s.startsWith("[C]")) {
                    this.fontRendererObj.drawStringWithShadow(s.substring(3), (float)(j + (274 - this.fontRendererObj.getStringWidth(s.substring(3))) / 2), (float)l, 16777215);
                }
                else {
                    this.fontRendererObj.fontRandom.setSeed(i2 * 4238972211L + this.time / 4);
                    this.fontRendererObj.drawStringWithShadow(s, (float)j, (float)l, 16777215);
                }
            }
            l += 12;
        }
        GlStateManager.popMatrix();
        this.mc.getTextureManager().bindTexture(GuiWinGame.VIGNETTE_TEXTURE);
        GlStateManager.enableBlend();
        GlStateManager.blendFunc(GlStateManager.SourceFactor.ZERO, GlStateManager.DestFactor.ONE_MINUS_SRC_COLOR);
        final int j2 = this.width;
        final int k2 = this.height;
        vertexbuffer.begin(7, DefaultVertexFormats.POSITION_TEX_COLOR);
        vertexbuffer.pos(0.0, k2, this.zLevel).tex(0.0, 1.0).color(1.0f, 1.0f, 1.0f, 1.0f).endVertex();
        vertexbuffer.pos(j2, k2, this.zLevel).tex(1.0, 1.0).color(1.0f, 1.0f, 1.0f, 1.0f).endVertex();
        vertexbuffer.pos(j2, 0.0, this.zLevel).tex(1.0, 0.0).color(1.0f, 1.0f, 1.0f, 1.0f).endVertex();
        vertexbuffer.pos(0.0, 0.0, this.zLevel).tex(0.0, 0.0).color(1.0f, 1.0f, 1.0f, 1.0f).endVertex();
        tessellator.draw();
        GlStateManager.disableBlend();
        super.drawScreen(mouseX, mouseY, partialTicks);
    }
}
