// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.client.gui.achievement;

import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.util.text.TextComponentTranslation;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.stats.Achievement;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import java.util.Random;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.math.MathHelper;
import org.lwjgl.input.Mouse;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import java.io.IOException;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiOptionButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.network.Packet;
import net.minecraft.network.play.client.CPacketClientStatus;
import net.minecraft.stats.AchievementList;
import net.minecraft.stats.StatisticsManager;
import net.minecraft.util.ResourceLocation;
import net.minecraft.client.gui.IProgressMeter;
import net.minecraft.client.gui.GuiScreen;

public class GuiAchievements extends GuiScreen implements IProgressMeter
{
    private static final int X_MIN;
    private static final int Y_MIN;
    private static final int X_MAX;
    private static final int Y_MAX;
    private static final ResourceLocation ACHIEVEMENT_BACKGROUND;
    protected GuiScreen parentScreen;
    protected int imageWidth;
    protected int imageHeight;
    protected int xLastScroll;
    protected int yLastScroll;
    protected float zoom;
    protected double xScrollO;
    protected double yScrollO;
    protected double xScrollP;
    protected double yScrollP;
    protected double xScrollTarget;
    protected double yScrollTarget;
    private int scrolling;
    private final StatisticsManager statFileWriter;
    private boolean loadingAchievements;
    
    static {
        X_MIN = AchievementList.minDisplayColumn * 24 - 112;
        Y_MIN = AchievementList.minDisplayRow * 24 - 112;
        X_MAX = AchievementList.maxDisplayColumn * 24 - 77;
        Y_MAX = AchievementList.maxDisplayRow * 24 - 77;
        ACHIEVEMENT_BACKGROUND = new ResourceLocation("textures/gui/achievement/achievement_background.png");
    }
    
    public GuiAchievements(final GuiScreen parentScreenIn, final StatisticsManager statFileWriterIn) {
        this.imageWidth = 256;
        this.imageHeight = 202;
        this.zoom = 1.0f;
        this.loadingAchievements = true;
        this.parentScreen = parentScreenIn;
        this.statFileWriter = statFileWriterIn;
        final int i = 141;
        final int j = 141;
        this.xScrollTarget = AchievementList.OPEN_INVENTORY.displayColumn * 24 - 70 - 12;
        this.xScrollO = this.xScrollTarget;
        this.xScrollP = this.xScrollTarget;
        this.yScrollTarget = AchievementList.OPEN_INVENTORY.displayRow * 24 - 70;
        this.yScrollO = this.yScrollTarget;
        this.yScrollP = this.yScrollTarget;
    }
    
    @Override
    public void initGui() {
        this.mc.getConnection().sendPacket(new CPacketClientStatus(CPacketClientStatus.State.REQUEST_STATS));
        this.buttonList.clear();
        this.buttonList.add(new GuiOptionButton(1, this.width / 2 + 24, this.height / 2 + 74, 80, 20, I18n.format("gui.done", new Object[0])));
    }
    
    @Override
    protected void actionPerformed(final GuiButton button) throws IOException {
        if (!this.loadingAchievements && button.id == 1) {
            this.mc.displayGuiScreen(this.parentScreen);
        }
    }
    
    @Override
    protected void keyTyped(final char typedChar, final int keyCode) throws IOException {
        if (keyCode == this.mc.gameSettings.keyBindInventory.getKeyCode()) {
            this.mc.displayGuiScreen(null);
            this.mc.setIngameFocus();
        }
        else {
            super.keyTyped(typedChar, keyCode);
        }
    }
    
    @Override
    public void drawScreen(final int mouseX, final int mouseY, final float partialTicks) {
        if (this.loadingAchievements) {
            this.drawDefaultBackground();
            Gui.drawCenteredString(this.fontRendererObj, I18n.format("multiplayer.downloadingStats", new Object[0]), (float)(this.width / 2), (float)(this.height / 2), 16777215);
            Gui.drawCenteredString(this.fontRendererObj, GuiAchievements.LOADING_STRINGS[(int)(Minecraft.getSystemTime() / 150L % GuiAchievements.LOADING_STRINGS.length)], (float)(this.width / 2), (float)(this.height / 2 + this.fontRendererObj.FONT_HEIGHT * 2), 16777215);
        }
        else {
            if (Mouse.isButtonDown(0)) {
                final int i = (this.width - this.imageWidth) / 2;
                final int j = (this.height - this.imageHeight) / 2;
                final int k = i + 8;
                final int l = j + 17;
                if ((this.scrolling == 0 || this.scrolling == 1) && mouseX >= k && mouseX < k + 224 && mouseY >= l && mouseY < l + 155) {
                    if (this.scrolling == 0) {
                        this.scrolling = 1;
                    }
                    else {
                        this.xScrollP -= (mouseX - this.xLastScroll) * this.zoom;
                        this.yScrollP -= (mouseY - this.yLastScroll) * this.zoom;
                        this.xScrollO = this.xScrollP;
                        this.yScrollO = this.yScrollP;
                        this.xScrollTarget = this.xScrollP;
                        this.yScrollTarget = this.yScrollP;
                    }
                    this.xLastScroll = mouseX;
                    this.yLastScroll = mouseY;
                }
            }
            else {
                this.scrolling = 0;
            }
            final int i2 = Mouse.getDWheel();
            final float f2 = this.zoom;
            if (i2 < 0) {
                this.zoom += 0.25f;
            }
            else if (i2 > 0) {
                this.zoom -= 0.25f;
            }
            this.zoom = MathHelper.clamp(this.zoom, 1.0f, 2.0f);
            if (this.zoom != f2) {
                final float f3 = f2 * this.imageWidth;
                final float f4 = f2 * this.imageHeight;
                final float f5 = this.zoom * this.imageWidth;
                final float f6 = this.zoom * this.imageHeight;
                this.xScrollP -= (f5 - f3) * 0.5f;
                this.yScrollP -= (f6 - f4) * 0.5f;
                this.xScrollO = this.xScrollP;
                this.yScrollO = this.yScrollP;
                this.xScrollTarget = this.xScrollP;
                this.yScrollTarget = this.yScrollP;
            }
            if (this.xScrollTarget < GuiAchievements.X_MIN) {
                this.xScrollTarget = GuiAchievements.X_MIN;
            }
            if (this.yScrollTarget < GuiAchievements.Y_MIN) {
                this.yScrollTarget = GuiAchievements.Y_MIN;
            }
            if (this.xScrollTarget >= GuiAchievements.X_MAX) {
                this.xScrollTarget = GuiAchievements.X_MAX - 1;
            }
            if (this.yScrollTarget >= GuiAchievements.Y_MAX) {
                this.yScrollTarget = GuiAchievements.Y_MAX - 1;
            }
            this.drawDefaultBackground();
            this.drawAchievementScreen(mouseX, mouseY, partialTicks);
            GlStateManager.disableLighting();
            GlStateManager.disableDepth();
            this.drawTitle();
            GlStateManager.enableLighting();
            GlStateManager.enableDepth();
        }
    }
    
    @Override
    public void doneLoading() {
        if (this.loadingAchievements) {
            this.loadingAchievements = false;
        }
    }
    
    @Override
    public void updateScreen() {
        if (!this.loadingAchievements) {
            this.xScrollO = this.xScrollP;
            this.yScrollO = this.yScrollP;
            final double d0 = this.xScrollTarget - this.xScrollP;
            final double d2 = this.yScrollTarget - this.yScrollP;
            if (d0 * d0 + d2 * d2 < 4.0) {
                this.xScrollP += d0;
                this.yScrollP += d2;
            }
            else {
                this.xScrollP += d0 * 0.85;
                this.yScrollP += d2 * 0.85;
            }
        }
    }
    
    protected void drawTitle() {
        final int i = (this.width - this.imageWidth) / 2;
        final int j = (this.height - this.imageHeight) / 2;
        this.fontRendererObj.drawString(I18n.format("gui.achievements", new Object[0]), i + 15, j + 5, 4210752);
    }
    
    protected void drawAchievementScreen(final int p_146552_1_, final int p_146552_2_, final float p_146552_3_) {
        int i = MathHelper.floor(this.xScrollO + (this.xScrollP - this.xScrollO) * p_146552_3_);
        int j = MathHelper.floor(this.yScrollO + (this.yScrollP - this.yScrollO) * p_146552_3_);
        if (i < GuiAchievements.X_MIN) {
            i = GuiAchievements.X_MIN;
        }
        if (j < GuiAchievements.Y_MIN) {
            j = GuiAchievements.Y_MIN;
        }
        if (i >= GuiAchievements.X_MAX) {
            i = GuiAchievements.X_MAX - 1;
        }
        if (j >= GuiAchievements.Y_MAX) {
            j = GuiAchievements.Y_MAX - 1;
        }
        final int k = (this.width - this.imageWidth) / 2;
        final int l = (this.height - this.imageHeight) / 2;
        final int i2 = k + 16;
        final int j2 = l + 17;
        this.zLevel = 0.0f;
        GlStateManager.depthFunc(518);
        GlStateManager.pushMatrix();
        GlStateManager.translate((float)i2, (float)j2, -200.0f);
        GlStateManager.scale(1.0f / this.zoom, 1.0f / this.zoom, 0.0f);
        GlStateManager.enableTexture2D();
        GlStateManager.disableLighting();
        GlStateManager.enableRescaleNormal();
        GlStateManager.enableColorMaterial();
        final int k2 = i + 288 >> 4;
        final int l2 = j + 288 >> 4;
        final int i3 = (i + 288) % 16;
        final int j3 = (j + 288) % 16;
        final int k3 = 4;
        final int l3 = 8;
        final int i4 = 10;
        final int j4 = 22;
        final int k4 = 37;
        final Random random = new Random();
        final float f = 16.0f / this.zoom;
        final float f2 = 16.0f / this.zoom;
        for (int l4 = 0; l4 * f - j3 < 155.0f; ++l4) {
            final float f3 = 0.6f - (l2 + l4) / 25.0f * 0.3f;
            GlStateManager.color(f3, f3, f3, 1.0f);
            for (int i5 = 0; i5 * f2 - i3 < 224.0f; ++i5) {
                random.setSeed(this.mc.getSession().getPlayerID().hashCode() + k2 + i5 + (l2 + l4) * 16);
                final int j5 = random.nextInt(1 + l2 + l4) + (l2 + l4) / 2;
                TextureAtlasSprite textureatlassprite = this.getTexture(Blocks.SAND);
                if (j5 <= 37 && l2 + l4 != 35) {
                    if (j5 == 22) {
                        if (random.nextInt(2) == 0) {
                            textureatlassprite = this.getTexture(Blocks.DIAMOND_ORE);
                        }
                        else {
                            textureatlassprite = this.getTexture(Blocks.REDSTONE_ORE);
                        }
                    }
                    else if (j5 == 10) {
                        textureatlassprite = this.getTexture(Blocks.IRON_ORE);
                    }
                    else if (j5 == 8) {
                        textureatlassprite = this.getTexture(Blocks.COAL_ORE);
                    }
                    else if (j5 > 4) {
                        textureatlassprite = this.getTexture(Blocks.STONE);
                    }
                    else if (j5 > 0) {
                        textureatlassprite = this.getTexture(Blocks.DIRT);
                    }
                }
                else {
                    final Block block = Blocks.BEDROCK;
                    textureatlassprite = this.getTexture(block);
                }
                this.mc.getTextureManager().bindTexture(TextureMap.LOCATION_BLOCKS_TEXTURE);
                this.drawTexturedModalRect(i5 * 16 - i3, l4 * 16 - j3, textureatlassprite, 16, 16);
            }
        }
        GlStateManager.enableDepth();
        GlStateManager.depthFunc(515);
        this.mc.getTextureManager().bindTexture(GuiAchievements.ACHIEVEMENT_BACKGROUND);
        for (int j6 = 0; j6 < AchievementList.ACHIEVEMENTS.size(); ++j6) {
            final Achievement achievement1 = AchievementList.ACHIEVEMENTS.get(j6);
            if (achievement1.parentAchievement != null) {
                final int k5 = achievement1.displayColumn * 24 - i + 11;
                final int l5 = achievement1.displayRow * 24 - j + 11;
                final int j7 = achievement1.parentAchievement.displayColumn * 24 - i + 11;
                final int k6 = achievement1.parentAchievement.displayRow * 24 - j + 11;
                final boolean flag = this.statFileWriter.hasAchievementUnlocked(achievement1);
                final boolean flag2 = this.statFileWriter.canUnlockAchievement(achievement1);
                final int k7 = this.statFileWriter.countRequirementsUntilAvailable(achievement1);
                if (k7 <= 4) {
                    int l6 = -16777216;
                    if (flag) {
                        l6 = -6250336;
                    }
                    else if (flag2) {
                        l6 = -16711936;
                    }
                    this.drawHorizontalLine(k5, j7, l5, l6);
                    this.drawVerticalLine(j7, l5, k6, l6);
                    if (k5 > j7) {
                        this.drawTexturedModalRect(k5 - 11 - 7, l5 - 5, 114, 234, 7, 11);
                    }
                    else if (k5 < j7) {
                        this.drawTexturedModalRect(k5 + 11, l5 - 5, 107, 234, 7, 11);
                    }
                    else if (l5 > k6) {
                        this.drawTexturedModalRect(k5 - 5, l5 - 11 - 7, 96, 234, 11, 7);
                    }
                    else if (l5 < k6) {
                        this.drawTexturedModalRect(k5 - 5, l5 + 11, 96, 241, 11, 7);
                    }
                }
            }
        }
        Achievement achievement2 = null;
        final float f4 = (p_146552_1_ - i2) * this.zoom;
        final float f5 = (p_146552_2_ - j2) * this.zoom;
        RenderHelper.enableGUIStandardItemLighting();
        GlStateManager.disableLighting();
        GlStateManager.enableRescaleNormal();
        GlStateManager.enableColorMaterial();
        for (int i6 = 0; i6 < AchievementList.ACHIEVEMENTS.size(); ++i6) {
            final Achievement achievement3 = AchievementList.ACHIEVEMENTS.get(i6);
            final int l7 = achievement3.displayColumn * 24 - i;
            final int j8 = achievement3.displayRow * 24 - j;
            if (l7 >= -24 && j8 >= -24 && l7 <= 224.0f * this.zoom && j8 <= 155.0f * this.zoom) {
                final int l8 = this.statFileWriter.countRequirementsUntilAvailable(achievement3);
                if (this.statFileWriter.hasAchievementUnlocked(achievement3)) {
                    final float f6 = 0.75f;
                    GlStateManager.color(0.75f, 0.75f, 0.75f, 1.0f);
                }
                else if (this.statFileWriter.canUnlockAchievement(achievement3)) {
                    final float f7 = 1.0f;
                    GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
                }
                else if (l8 < 3) {
                    final float f8 = 0.3f;
                    GlStateManager.color(0.3f, 0.3f, 0.3f, 1.0f);
                }
                else if (l8 == 3) {
                    final float f9 = 0.2f;
                    GlStateManager.color(0.2f, 0.2f, 0.2f, 1.0f);
                }
                else {
                    if (l8 != 4) {
                        continue;
                    }
                    final float f10 = 0.1f;
                    GlStateManager.color(0.1f, 0.1f, 0.1f, 1.0f);
                }
                this.mc.getTextureManager().bindTexture(GuiAchievements.ACHIEVEMENT_BACKGROUND);
                if (achievement3.getSpecial()) {
                    this.drawTexturedModalRect(l7 - 2, j8 - 2, 26, 202, 26, 26);
                }
                else {
                    this.drawTexturedModalRect(l7 - 2, j8 - 2, 0, 202, 26, 26);
                }
                if (!this.statFileWriter.canUnlockAchievement(achievement3)) {
                    final float f11 = 0.1f;
                    GlStateManager.color(0.1f, 0.1f, 0.1f, 1.0f);
                    this.itemRender.isNotRenderingEffectsInGUI(false);
                }
                GlStateManager.enableLighting();
                GlStateManager.enableCull();
                this.itemRender.renderItemAndEffectIntoGUI(achievement3.theItemStack, l7 + 3, j8 + 3);
                GlStateManager.blendFunc(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
                GlStateManager.disableLighting();
                if (!this.statFileWriter.canUnlockAchievement(achievement3)) {
                    this.itemRender.isNotRenderingEffectsInGUI(true);
                }
                GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
                if (f4 >= l7 && f4 <= l7 + 22 && f5 >= j8 && f5 <= j8 + 22) {
                    achievement2 = achievement3;
                }
            }
        }
        GlStateManager.disableDepth();
        GlStateManager.enableBlend();
        GlStateManager.popMatrix();
        GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f);
        this.mc.getTextureManager().bindTexture(GuiAchievements.ACHIEVEMENT_BACKGROUND);
        this.drawTexturedModalRect(k, l, 0, 0, this.imageWidth, this.imageHeight);
        this.zLevel = 0.0f;
        GlStateManager.depthFunc(515);
        GlStateManager.disableDepth();
        GlStateManager.enableTexture2D();
        super.drawScreen(p_146552_1_, p_146552_2_, p_146552_3_);
        if (achievement2 != null) {
            String s = achievement2.getStatName().getUnformattedText();
            final String s2 = achievement2.getDescription();
            final int i7 = p_146552_1_ + 12;
            final int k8 = p_146552_2_ - 4;
            final int i8 = this.statFileWriter.countRequirementsUntilAvailable(achievement2);
            if (this.statFileWriter.canUnlockAchievement(achievement2)) {
                final int j9 = Math.max(this.fontRendererObj.getStringWidth(s), 120);
                int i9 = this.fontRendererObj.splitStringWidth(s2, j9);
                if (this.statFileWriter.hasAchievementUnlocked(achievement2)) {
                    i9 += 12;
                }
                this.drawGradientRect(i7 - 3, k8 - 3, i7 + j9 + 3, k8 + i9 + 3 + 12, -1073741824, -1073741824);
                this.fontRendererObj.drawSplitString(s2, i7, k8 + 12, j9, -6250336);
                if (this.statFileWriter.hasAchievementUnlocked(achievement2)) {
                    this.fontRendererObj.drawStringWithShadow(I18n.format("achievement.taken", new Object[0]), (float)i7, (float)(k8 + i9 + 4), -7302913);
                }
            }
            else if (i8 == 3) {
                s = I18n.format("achievement.unknown", new Object[0]);
                final int k9 = Math.max(this.fontRendererObj.getStringWidth(s), 120);
                final String s3 = new TextComponentTranslation("achievement.requires", new Object[] { achievement2.parentAchievement.getStatName() }).getUnformattedText();
                final int i10 = this.fontRendererObj.splitStringWidth(s3, k9);
                this.drawGradientRect(i7 - 3, k8 - 3, i7 + k9 + 3, k8 + i10 + 12 + 3, -1073741824, -1073741824);
                this.fontRendererObj.drawSplitString(s3, i7, k8 + 12, k9, -9416624);
            }
            else if (i8 < 3) {
                final int l9 = Math.max(this.fontRendererObj.getStringWidth(s), 120);
                final String s4 = new TextComponentTranslation("achievement.requires", new Object[] { achievement2.parentAchievement.getStatName() }).getUnformattedText();
                final int j10 = this.fontRendererObj.splitStringWidth(s4, l9);
                this.drawGradientRect(i7 - 3, k8 - 3, i7 + l9 + 3, k8 + j10 + 12 + 3, -1073741824, -1073741824);
                this.fontRendererObj.drawSplitString(s4, i7, k8 + 12, l9, -9416624);
            }
            else {
                s = null;
            }
            if (s != null) {
                this.fontRendererObj.drawStringWithShadow(s, (float)i7, (float)k8, this.statFileWriter.canUnlockAchievement(achievement2) ? (achievement2.getSpecial() ? -128 : -1) : (achievement2.getSpecial() ? -8355776 : -8355712));
            }
        }
        GlStateManager.enableDepth();
        GlStateManager.enableLighting();
        RenderHelper.disableStandardItemLighting();
    }
    
    private TextureAtlasSprite getTexture(final Block blockIn) {
        return Minecraft.getMinecraft().getBlockRendererDispatcher().getBlockModelShapes().getTexture(blockIn.getDefaultState());
    }
    
    @Override
    public boolean doesGuiPauseGame() {
        return !this.loadingAchievements;
    }
}
