// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.client.renderer.texture;

import net.minecraft.client.renderer.GlStateManager;
import java.awt.image.BufferedImage;
import java.util.Set;
import java.awt.Dimension;
import java.io.InputStream;
import java.util.Collection;
import java.util.TreeSet;
import java.util.HashMap;
import net.minecraft.crash.ICrashReportDetail;
import net.minecraft.crash.CrashReportCategory;
import net.minecraft.client.resources.IResource;
import java.util.Iterator;
import net.minecraft.util.ReportedException;
import net.minecraft.crash.CrashReport;
import net.minecraft.client.renderer.StitcherException;
import net.minecraft.util.math.MathHelper;
import java.io.Closeable;
import org.apache.commons.io.IOUtils;
import net.minecraft.src.ReflectorForge;
import net.minecraft.src.TextureUtils;
import net.minecraft.src.BetterGrass;
import net.minecraft.src.CustomItems;
import net.minecraft.src.ConnectedTextures;
import net.minecraft.src.Config;
import net.minecraft.src.Reflector;
import java.io.IOException;
import shadersmod.client.ShadersTex;
import net.minecraft.client.resources.IResourceManager;
import com.google.common.collect.Maps;
import com.google.common.collect.Lists;
import javax.annotation.Nullable;
import org.apache.logging.log4j.LogManager;
import java.util.Map;
import java.util.List;
import net.minecraft.util.ResourceLocation;
import org.apache.logging.log4j.Logger;

public class TextureMap extends AbstractTexture implements ITickableTextureObject
{
    private static final boolean ENABLE_SKIP;
    private static final Logger LOGGER;
    public static final ResourceLocation LOCATION_MISSING_TEXTURE;
    public static final ResourceLocation LOCATION_BLOCKS_TEXTURE;
    private final List<TextureAtlasSprite> listAnimatedSprites;
    private final Map<String, TextureAtlasSprite> mapRegisteredSprites;
    private final Map<String, TextureAtlasSprite> mapUploadedSprites;
    private final String basePath;
    private final ITextureMapPopulator iconCreator;
    private int mipmapLevels;
    private final TextureAtlasSprite missingImage;
    private boolean skipFirst;
    private TextureAtlasSprite[] iconGrid;
    private int iconGridSize;
    private int iconGridCountX;
    private int iconGridCountY;
    private double iconGridSizeU;
    private double iconGridSizeV;
    private int counterIndexInMap;
    public int atlasWidth;
    public int atlasHeight;
    
    static {
        ENABLE_SKIP = Boolean.parseBoolean(System.getProperty("fml.skipFirstTextureLoad", "true"));
        LOGGER = LogManager.getLogger();
        LOCATION_MISSING_TEXTURE = new ResourceLocation("missingno");
        LOCATION_BLOCKS_TEXTURE = new ResourceLocation("textures/atlas/blocks.png");
    }
    
    public TextureMap(final String basePathIn) {
        this(basePathIn, null);
    }
    
    public TextureMap(final String p_i5_1_, final boolean p_i5_2_) {
        this(p_i5_1_, null, p_i5_2_);
    }
    
    public TextureMap(final String basePathIn, @Nullable final ITextureMapPopulator iconCreatorIn) {
        this(basePathIn, iconCreatorIn, false);
    }
    
    public TextureMap(final String p_i6_1_, final ITextureMapPopulator p_i6_2_, final boolean p_i6_3_) {
        this.skipFirst = false;
        this.iconGrid = null;
        this.iconGridSize = -1;
        this.iconGridCountX = -1;
        this.iconGridCountY = -1;
        this.iconGridSizeU = -1.0;
        this.iconGridSizeV = -1.0;
        this.counterIndexInMap = 0;
        this.atlasWidth = 0;
        this.atlasHeight = 0;
        this.listAnimatedSprites = (List<TextureAtlasSprite>)Lists.newArrayList();
        this.mapRegisteredSprites = (Map<String, TextureAtlasSprite>)Maps.newHashMap();
        this.mapUploadedSprites = (Map<String, TextureAtlasSprite>)Maps.newHashMap();
        this.missingImage = new TextureAtlasSprite("missingno");
        this.basePath = p_i6_1_;
        this.iconCreator = p_i6_2_;
        this.skipFirst = (p_i6_3_ && TextureMap.ENABLE_SKIP);
    }
    
    private void initMissingImage() {
        final int i = this.getMinSpriteSize();
        final int[] aint = this.getMissingImageData(i);
        this.missingImage.setIconWidth(i);
        this.missingImage.setIconHeight(i);
        final int[][] aint2 = new int[this.mipmapLevels + 1][];
        aint2[0] = aint;
        this.missingImage.setFramesTextureData(Lists.newArrayList((Object[])new int[][][] { aint2 }));
        this.missingImage.setIndexInMap(this.counterIndexInMap++);
    }
    
    @Override
    public void loadTexture(final IResourceManager resourceManager) throws IOException {
        ShadersTex.resManager = resourceManager;
        if (this.iconCreator != null) {
            this.loadSprites(resourceManager, this.iconCreator);
        }
    }
    
    public void loadSprites(final IResourceManager resourceManager, final ITextureMapPopulator iconCreatorIn) {
        this.mapRegisteredSprites.clear();
        this.counterIndexInMap = 0;
        Reflector.callVoid(Reflector.ForgeHooksClient_onTextureStitchedPre, this);
        iconCreatorIn.registerSprites(this);
        if (this.mipmapLevels >= 4) {
            this.mipmapLevels = this.detectMaxMipmapLevel(this.mapRegisteredSprites, resourceManager);
            Config.log("Mipmap levels: " + this.mipmapLevels);
        }
        this.initMissingImage();
        this.deleteGlTexture();
        this.loadTextureAtlas(resourceManager);
    }
    
    public void loadTextureAtlas(final IResourceManager resourceManager) {
        ShadersTex.resManager = resourceManager;
        Config.dbg("Multitexture: " + Config.isMultiTexture());
        if (Config.isMultiTexture()) {
            for (final TextureAtlasSprite textureatlassprite : this.mapUploadedSprites.values()) {
                textureatlassprite.deleteSpriteTexture();
            }
        }
        ConnectedTextures.updateIcons(this);
        CustomItems.updateIcons(this);
        BetterGrass.updateIcons(this);
        final int j1 = TextureUtils.getGLMaximumTextureSize();
        final Stitcher stitcher = new Stitcher(j1, j1, 0, this.mipmapLevels);
        this.mapUploadedSprites.clear();
        this.listAnimatedSprites.clear();
        int i = Integer.MAX_VALUE;
        final int k = this.getMinSpriteSize();
        this.iconGridSize = k;
        int l = 1 << this.mipmapLevels;
        for (final Map.Entry<String, TextureAtlasSprite> entry : this.mapRegisteredSprites.entrySet()) {
            if (this.skipFirst) {
                break;
            }
            final TextureAtlasSprite textureatlassprite2 = entry.getValue();
            final ResourceLocation resourcelocation = this.getResourceLocation(textureatlassprite2);
            IResource iresource = null;
            if (textureatlassprite2.getIndexInMap() < 0) {
                textureatlassprite2.setIndexInMap(this.counterIndexInMap++);
            }
            if (textureatlassprite2.hasCustomLoader(resourceManager, resourcelocation)) {
                if (textureatlassprite2.load(resourceManager, resourcelocation)) {
                    Config.dbg("Custom loader (skipped): " + textureatlassprite2);
                    continue;
                }
                Config.dbg("Custom loader: " + textureatlassprite2);
            }
            else {
                try {
                    final PngSizeInfo pngsizeinfo = PngSizeInfo.makeFromResource(resourceManager.getResource(resourcelocation));
                    if (Config.isShaders()) {
                        iresource = ShadersTex.loadResource(resourceManager, resourcelocation);
                    }
                    else {
                        iresource = resourceManager.getResource(resourcelocation);
                    }
                    final boolean flag = iresource.getMetadata("animation") != null;
                    textureatlassprite2.loadSprite(pngsizeinfo, flag);
                }
                catch (RuntimeException runtimeexception) {
                    TextureMap.LOGGER.error("Unable to parse metadata from {}", new Object[] { resourcelocation, runtimeexception });
                    ReflectorForge.FMLClientHandler_trackBrokenTexture(resourcelocation, runtimeexception.getMessage());
                }
                catch (IOException ioexception) {
                    TextureMap.LOGGER.error("Using missing texture, unable to load " + resourcelocation + ", " + ioexception.getClass().getName());
                    ReflectorForge.FMLClientHandler_trackMissingTexture(resourcelocation);
                }
                finally {
                    IOUtils.closeQuietly((Closeable)iresource);
                }
                IOUtils.closeQuietly((Closeable)iresource);
            }
            final int k2 = textureatlassprite2.getIconWidth();
            final int l2 = textureatlassprite2.getIconHeight();
            if (k2 >= 1 && l2 >= 1) {
                if (k2 < k || this.mipmapLevels > 0) {
                    final int m = (this.mipmapLevels > 0) ? TextureUtils.scaleToPowerOfTwo(k2, k) : TextureUtils.scaleMinTo(k2, k);
                    if (m != k2) {
                        if (!TextureUtils.isPowerOfTwo(k2)) {
                            Config.log("Scaled non power of 2: " + textureatlassprite2.getIconName() + ", " + k2 + " -> " + m);
                        }
                        else {
                            Config.log("Scaled too small texture: " + textureatlassprite2.getIconName() + ", " + k2 + " -> " + m);
                        }
                        final int i2 = l2 * m / k2;
                        textureatlassprite2.setIconWidth(m);
                        textureatlassprite2.setIconHeight(i2);
                    }
                }
                i = Math.min(i, Math.min(textureatlassprite2.getIconWidth(), textureatlassprite2.getIconHeight()));
                final int i3 = Math.min(Integer.lowestOneBit(textureatlassprite2.getIconWidth()), Integer.lowestOneBit(textureatlassprite2.getIconHeight()));
                if (i3 < l) {
                    TextureMap.LOGGER.warn("Texture {} with size {}x{} limits mip level from {} to {}", new Object[] { resourcelocation, textureatlassprite2.getIconWidth(), textureatlassprite2.getIconHeight(), MathHelper.log2(l), MathHelper.log2(i3) });
                    l = i3;
                }
                stitcher.addSprite(textureatlassprite2);
            }
            else {
                Config.warn("Invalid sprite size: " + textureatlassprite2);
            }
        }
        final int k3 = Math.min(i, l);
        int l3 = MathHelper.log2(k3);
        if (l3 < 0) {
            l3 = 0;
        }
        if (l3 < this.mipmapLevels) {
            TextureMap.LOGGER.warn("{}: dropping miplevel from {} to {}, because of minimum power of two: {}", new Object[] { this.basePath, this.mipmapLevels, l3, k3 });
            this.mipmapLevels = l3;
        }
        this.missingImage.generateMipmaps(this.mipmapLevels);
        stitcher.addSprite(this.missingImage);
        this.skipFirst = false;
        try {
            stitcher.doStitch();
        }
        catch (StitcherException stitcherexception) {
            throw stitcherexception;
        }
        TextureMap.LOGGER.info("Created: {}x{} {}-atlas", new Object[] { stitcher.getCurrentWidth(), stitcher.getCurrentHeight(), this.basePath });
        if (Config.isShaders()) {
            ShadersTex.allocateTextureMap(this.getGlTextureId(), this.mipmapLevels, stitcher.getCurrentWidth(), stitcher.getCurrentHeight(), stitcher, this);
        }
        else {
            TextureUtil.allocateTextureImpl(this.getGlTextureId(), this.mipmapLevels, stitcher.getCurrentWidth(), stitcher.getCurrentHeight());
        }
        final Map<String, TextureAtlasSprite> map = (Map<String, TextureAtlasSprite>)Maps.newHashMap((Map)this.mapRegisteredSprites);
        for (final TextureAtlasSprite textureatlassprite3 : stitcher.getStichSlots()) {
            if (Config.isShaders()) {
                ShadersTex.setIconName(ShadersTex.setSprite(textureatlassprite3).getIconName());
            }
            if (textureatlassprite3 == this.missingImage || this.generateMipmaps(resourceManager, textureatlassprite3)) {
                final String s = textureatlassprite3.getIconName();
                map.remove(s);
                this.mapUploadedSprites.put(s, textureatlassprite3);
                try {
                    if (Config.isShaders()) {
                        ShadersTex.uploadTexSubForLoadAtlas(textureatlassprite3.getFrameTextureData(0), textureatlassprite3.getIconWidth(), textureatlassprite3.getIconHeight(), textureatlassprite3.getOriginX(), textureatlassprite3.getOriginY(), false, false);
                    }
                    else {
                        TextureUtil.uploadTextureMipmap(textureatlassprite3.getFrameTextureData(0), textureatlassprite3.getIconWidth(), textureatlassprite3.getIconHeight(), textureatlassprite3.getOriginX(), textureatlassprite3.getOriginY(), false, false);
                    }
                }
                catch (Throwable throwable) {
                    final CrashReport crashreport = CrashReport.makeCrashReport(throwable, "Stitching texture atlas");
                    final CrashReportCategory crashreportcategory = crashreport.makeCategory("Texture being stitched together");
                    crashreportcategory.addCrashSection("Atlas path", this.basePath);
                    crashreportcategory.addCrashSection("Sprite", textureatlassprite3);
                    throw new ReportedException(crashreport);
                }
                if (!textureatlassprite3.hasAnimationMetadata()) {
                    continue;
                }
                this.listAnimatedSprites.add(textureatlassprite3);
            }
        }
        for (final TextureAtlasSprite textureatlassprite4 : map.values()) {
            textureatlassprite4.copyFrom(this.missingImage);
        }
        if (Config.isMultiTexture()) {
            final int i4 = stitcher.getCurrentWidth();
            final int j2 = stitcher.getCurrentHeight();
            for (final TextureAtlasSprite textureatlassprite5 : stitcher.getStichSlots()) {
                textureatlassprite5.sheetWidth = i4;
                textureatlassprite5.sheetHeight = j2;
                textureatlassprite5.mipmapLevels = this.mipmapLevels;
                final TextureAtlasSprite textureatlassprite6 = textureatlassprite5.spriteSingle;
                if (textureatlassprite6 != null) {
                    if (textureatlassprite6.getIconWidth() <= 0) {
                        textureatlassprite6.setIconWidth(textureatlassprite5.getIconWidth());
                        textureatlassprite6.setIconHeight(textureatlassprite5.getIconHeight());
                        textureatlassprite6.initSprite(textureatlassprite5.getIconWidth(), textureatlassprite5.getIconHeight(), 0, 0, false);
                        textureatlassprite6.clearFramesTextureData();
                        final List<int[][]> list = textureatlassprite5.getFramesTextureData();
                        textureatlassprite6.setFramesTextureData(list);
                        textureatlassprite6.setAnimationMetadata(textureatlassprite5.getAnimationMetadata());
                    }
                    textureatlassprite6.sheetWidth = i4;
                    textureatlassprite6.sheetHeight = j2;
                    textureatlassprite6.mipmapLevels = this.mipmapLevels;
                    textureatlassprite5.bindSpriteTexture();
                    final boolean flag2 = false;
                    final boolean flag3 = true;
                    try {
                        TextureUtil.uploadTextureMipmap(textureatlassprite6.getFrameTextureData(0), textureatlassprite6.getIconWidth(), textureatlassprite6.getIconHeight(), textureatlassprite6.getOriginX(), textureatlassprite6.getOriginY(), flag2, flag3);
                    }
                    catch (Exception exception) {
                        Config.dbg("Error uploading sprite single: " + textureatlassprite6 + ", parent: " + textureatlassprite5);
                        exception.printStackTrace();
                    }
                }
            }
            Config.getMinecraft().getTextureManager().bindTexture(TextureMap.LOCATION_BLOCKS_TEXTURE);
        }
        Reflector.callVoid(Reflector.ForgeHooksClient_onTextureStitchedPost, this);
        this.updateIconGrid(stitcher.getCurrentWidth(), stitcher.getCurrentHeight());
        if (Config.equals(System.getProperty("saveTextureMap"), "true")) {
            Config.dbg("Exporting texture map: " + this.basePath);
            TextureUtils.saveGlTexture("debug/" + this.basePath.replaceAll("/", "_"), this.getGlTextureId(), this.mipmapLevels, stitcher.getCurrentWidth(), stitcher.getCurrentHeight());
        }
    }
    
    public boolean generateMipmaps(final IResourceManager resourceManager, final TextureAtlasSprite texture) {
        final ResourceLocation resourcelocation = this.getResourceLocation(texture);
        IResource iresource = null;
        if (!texture.hasCustomLoader(resourceManager, resourcelocation)) {
            boolean flag1 = false;
            try {
                iresource = resourceManager.getResource(resourcelocation);
                texture.loadSpriteFrames(iresource, this.mipmapLevels + 1);
            }
            catch (RuntimeException runtimeexception1) {
                TextureMap.LOGGER.error("Unable to parse metadata from {}", new Object[] { resourcelocation, runtimeexception1 });
                flag1 = false;
            }
            catch (IOException ioexception) {
                TextureMap.LOGGER.error("Using missing texture, unable to load {}", new Object[] { resourcelocation, ioexception });
                final boolean crashreportcategory;
                flag1 = (crashreportcategory = false);
                return crashreportcategory;
            }
            finally {
                IOUtils.closeQuietly((Closeable)iresource);
            }
            return flag1;
        }
        TextureUtils.generateCustomMipmaps(texture, this.mipmapLevels);
        try {
            texture.generateMipmaps(this.mipmapLevels);
            return true;
        }
        catch (Throwable throwable) {
            final CrashReport crashreport = CrashReport.makeCrashReport(throwable, "Applying mipmap");
            final CrashReportCategory crashreportcategory2 = crashreport.makeCategory("Sprite being mipmapped");
            crashreportcategory2.setDetail("Sprite name", new ICrashReportDetail<String>() {
                @Override
                public String call() throws Exception {
                    return texture.getIconName();
                }
            });
            crashreportcategory2.setDetail("Sprite size", new ICrashReportDetail<String>() {
                @Override
                public String call() throws Exception {
                    return String.valueOf(texture.getIconWidth()) + " x " + texture.getIconHeight();
                }
            });
            crashreportcategory2.setDetail("Sprite frames", new ICrashReportDetail<String>() {
                @Override
                public String call() throws Exception {
                    return String.valueOf(texture.getFrameCount()) + " frames";
                }
            });
            crashreportcategory2.addCrashSection("Mipmap levels", this.mipmapLevels);
            throw new ReportedException(crashreport);
        }
    }
    
    public ResourceLocation getResourceLocation(final TextureAtlasSprite p_184396_1_) {
        final ResourceLocation resourcelocation = new ResourceLocation(p_184396_1_.getIconName());
        return this.completeResourceLocation(resourcelocation);
    }
    
    public ResourceLocation completeResourceLocation(final ResourceLocation p_completeResourceLocation_1_) {
        return this.isAbsoluteLocation(p_completeResourceLocation_1_) ? new ResourceLocation(p_completeResourceLocation_1_.getResourceDomain(), String.valueOf(p_completeResourceLocation_1_.getResourcePath()) + ".png") : new ResourceLocation(p_completeResourceLocation_1_.getResourceDomain(), String.format("%s/%s%s", this.basePath, p_completeResourceLocation_1_.getResourcePath(), ".png"));
    }
    
    public TextureAtlasSprite getAtlasSprite(final String iconName) {
        TextureAtlasSprite textureatlassprite = this.mapUploadedSprites.get(iconName);
        if (textureatlassprite == null) {
            textureatlassprite = this.missingImage;
        }
        return textureatlassprite;
    }
    
    public void updateAnimations() {
        if (Config.isShaders()) {
            ShadersTex.updatingTex = this.getMultiTexID();
        }
        boolean flag = false;
        boolean flag2 = false;
        TextureUtil.bindTexture(this.getGlTextureId());
        for (final TextureAtlasSprite textureatlassprite : this.listAnimatedSprites) {
            if (this.isTerrainAnimationActive(textureatlassprite)) {
                textureatlassprite.updateAnimation();
                if (textureatlassprite.spriteNormal != null) {
                    flag = true;
                }
                if (textureatlassprite.spriteSpecular == null) {
                    continue;
                }
                flag2 = true;
            }
        }
        if (Config.isMultiTexture()) {
            for (final TextureAtlasSprite textureatlassprite2 : this.listAnimatedSprites) {
                if (this.isTerrainAnimationActive(textureatlassprite2)) {
                    final TextureAtlasSprite textureatlassprite3 = textureatlassprite2.spriteSingle;
                    if (textureatlassprite3 == null) {
                        continue;
                    }
                    if (textureatlassprite2 == TextureUtils.iconClock || textureatlassprite2 == TextureUtils.iconCompass) {
                        textureatlassprite3.frameCounter = textureatlassprite2.frameCounter;
                    }
                    textureatlassprite2.bindSpriteTexture();
                    textureatlassprite3.updateAnimation();
                }
            }
            TextureUtil.bindTexture(this.getGlTextureId());
        }
        if (Config.isShaders()) {
            if (flag) {
                TextureUtil.bindTexture(this.getMultiTexID().norm);
                for (final TextureAtlasSprite textureatlassprite4 : this.listAnimatedSprites) {
                    if (textureatlassprite4.spriteNormal != null && this.isTerrainAnimationActive(textureatlassprite4)) {
                        if (textureatlassprite4 == TextureUtils.iconClock || textureatlassprite4 == TextureUtils.iconCompass) {
                            textureatlassprite4.spriteNormal.frameCounter = textureatlassprite4.frameCounter;
                        }
                        textureatlassprite4.spriteNormal.updateAnimation();
                    }
                }
            }
            if (flag2) {
                TextureUtil.bindTexture(this.getMultiTexID().spec);
                for (final TextureAtlasSprite textureatlassprite5 : this.listAnimatedSprites) {
                    if (textureatlassprite5.spriteSpecular != null && this.isTerrainAnimationActive(textureatlassprite5)) {
                        if (textureatlassprite5 == TextureUtils.iconClock || textureatlassprite5 == TextureUtils.iconCompass) {
                            textureatlassprite5.spriteNormal.frameCounter = textureatlassprite5.frameCounter;
                        }
                        textureatlassprite5.spriteSpecular.updateAnimation();
                    }
                }
            }
            if (flag || flag2) {
                TextureUtil.bindTexture(this.getGlTextureId());
            }
        }
        if (Config.isShaders()) {
            ShadersTex.updatingTex = null;
        }
    }
    
    public TextureAtlasSprite registerSprite(final ResourceLocation location) {
        if (location == null) {
            throw new IllegalArgumentException("Location cannot be null!");
        }
        TextureAtlasSprite textureatlassprite = this.mapRegisteredSprites.get(location.toString());
        if (textureatlassprite == null) {
            textureatlassprite = TextureAtlasSprite.makeAtlasSprite(location);
            this.mapRegisteredSprites.put(location.toString(), textureatlassprite);
            if (textureatlassprite.getIndexInMap() < 0) {
                textureatlassprite.setIndexInMap(this.counterIndexInMap++);
            }
        }
        return textureatlassprite;
    }
    
    @Override
    public void tick() {
        this.updateAnimations();
    }
    
    public void setMipmapLevels(final int mipmapLevelsIn) {
        this.mipmapLevels = mipmapLevelsIn;
    }
    
    public TextureAtlasSprite getMissingSprite() {
        return this.missingImage;
    }
    
    @Nullable
    public TextureAtlasSprite getTextureExtry(final String p_getTextureExtry_1_) {
        return this.mapRegisteredSprites.get(p_getTextureExtry_1_);
    }
    
    public boolean setTextureEntry(final TextureAtlasSprite p_setTextureEntry_1_) {
        final String s = p_setTextureEntry_1_.getIconName();
        if (!this.mapRegisteredSprites.containsKey(s)) {
            this.mapRegisteredSprites.put(s, p_setTextureEntry_1_);
            if (p_setTextureEntry_1_.getIndexInMap() < 0) {
                p_setTextureEntry_1_.setIndexInMap(this.counterIndexInMap++);
            }
            return true;
        }
        return false;
    }
    
    public String getBasePath() {
        return this.basePath;
    }
    
    public int getMipmapLevels() {
        return this.mipmapLevels;
    }
    
    private boolean isAbsoluteLocation(final ResourceLocation p_isAbsoluteLocation_1_) {
        final String s = p_isAbsoluteLocation_1_.getResourcePath();
        return this.isAbsoluteLocationPath(s);
    }
    
    private boolean isAbsoluteLocationPath(final String p_isAbsoluteLocationPath_1_) {
        final String s = p_isAbsoluteLocationPath_1_.toLowerCase();
        return s.startsWith("mcpatcher/") || s.startsWith("optifine/");
    }
    
    public TextureAtlasSprite getSpriteSafe(final String p_getSpriteSafe_1_) {
        final ResourceLocation resourcelocation = new ResourceLocation(p_getSpriteSafe_1_);
        return this.mapRegisteredSprites.get(resourcelocation.toString());
    }
    
    private boolean isTerrainAnimationActive(final TextureAtlasSprite p_isTerrainAnimationActive_1_) {
        return (p_isTerrainAnimationActive_1_ != TextureUtils.iconWaterStill && p_isTerrainAnimationActive_1_ != TextureUtils.iconWaterFlow) ? ((p_isTerrainAnimationActive_1_ != TextureUtils.iconLavaStill && p_isTerrainAnimationActive_1_ != TextureUtils.iconLavaFlow) ? ((p_isTerrainAnimationActive_1_ != TextureUtils.iconFireLayer0 && p_isTerrainAnimationActive_1_ != TextureUtils.iconFireLayer1) ? ((p_isTerrainAnimationActive_1_ == TextureUtils.iconPortal) ? Config.isAnimatedPortal() : (p_isTerrainAnimationActive_1_ == TextureUtils.iconClock || p_isTerrainAnimationActive_1_ == TextureUtils.iconCompass || Config.isAnimatedTerrain())) : Config.isAnimatedFire()) : Config.isAnimatedLava()) : Config.isAnimatedWater();
    }
    
    public int getCountRegisteredSprites() {
        return this.counterIndexInMap;
    }
    
    private int detectMaxMipmapLevel(final Map p_detectMaxMipmapLevel_1_, final IResourceManager p_detectMaxMipmapLevel_2_) {
        int i = this.detectMinimumSpriteSize(p_detectMaxMipmapLevel_1_, p_detectMaxMipmapLevel_2_, 20);
        if (i < 16) {
            i = 16;
        }
        i = MathHelper.smallestEncompassingPowerOfTwo(i);
        if (i > 16) {
            Config.log("Sprite size: " + i);
        }
        int j = MathHelper.log2(i);
        if (j < 4) {
            j = 4;
        }
        return j;
    }
    
    private int detectMinimumSpriteSize(final Map p_detectMinimumSpriteSize_1_, final IResourceManager p_detectMinimumSpriteSize_2_, final int p_detectMinimumSpriteSize_3_) {
        final Map map = new HashMap();
        for (final Object entry : p_detectMinimumSpriteSize_1_.entrySet()) {
            final TextureAtlasSprite textureatlassprite = ((Map.Entry)entry).getValue();
            final ResourceLocation resourcelocation = new ResourceLocation(textureatlassprite.getIconName());
            final ResourceLocation resourcelocation2 = this.completeResourceLocation(resourcelocation);
            if (!textureatlassprite.hasCustomLoader(p_detectMinimumSpriteSize_2_, resourcelocation)) {
                try {
                    final IResource iresource = p_detectMinimumSpriteSize_2_.getResource(resourcelocation2);
                    if (iresource == null) {
                        continue;
                    }
                    final InputStream inputstream = iresource.getInputStream();
                    if (inputstream == null) {
                        continue;
                    }
                    final Dimension dimension = TextureUtils.getImageSize(inputstream, "png");
                    if (dimension == null) {
                        continue;
                    }
                    final int i = dimension.width;
                    final int j = MathHelper.smallestEncompassingPowerOfTwo(i);
                    if (!map.containsKey(j)) {
                        map.put(j, 1);
                    }
                    else {
                        final int k = map.get(j);
                        map.put(j, k + 1);
                    }
                }
                catch (Exception ex) {}
            }
        }
        int l = 0;
        final Set set = map.keySet();
        final Set set2 = new TreeSet(set);
        for (final int j2 : set2) {
            final int l2 = map.get(j2);
            l += l2;
        }
        int i2 = 16;
        int k2 = 0;
        final int l2 = l * p_detectMinimumSpriteSize_3_ / 100;
        for (final int i3 : set2) {
            final int j3 = map.get(i3);
            k2 += j3;
            if (i3 > i2) {
                i2 = i3;
            }
            if (k2 > l2) {
                return i2;
            }
        }
        return i2;
    }
    
    private int getMinSpriteSize() {
        int i = 1 << this.mipmapLevels;
        if (i < 8) {
            i = 8;
        }
        return i;
    }
    
    private int[] getMissingImageData(final int p_getMissingImageData_1_) {
        final BufferedImage bufferedimage = new BufferedImage(16, 16, 2);
        bufferedimage.setRGB(0, 0, 16, 16, TextureUtil.MISSING_TEXTURE_DATA, 0, 16);
        final BufferedImage bufferedimage2 = TextureUtils.scaleToPowerOfTwo(bufferedimage, p_getMissingImageData_1_);
        final int[] aint = new int[p_getMissingImageData_1_ * p_getMissingImageData_1_];
        bufferedimage2.getRGB(0, 0, p_getMissingImageData_1_, p_getMissingImageData_1_, aint, 0, p_getMissingImageData_1_);
        return aint;
    }
    
    public boolean isTextureBound() {
        final int i = GlStateManager.getBoundTexture();
        final int j = this.getGlTextureId();
        return i == j;
    }
    
    private void updateIconGrid(final int p_updateIconGrid_1_, final int p_updateIconGrid_2_) {
        this.iconGridCountX = -1;
        this.iconGridCountY = -1;
        this.iconGrid = null;
        if (this.iconGridSize > 0) {
            this.iconGridCountX = p_updateIconGrid_1_ / this.iconGridSize;
            this.iconGridCountY = p_updateIconGrid_2_ / this.iconGridSize;
            this.iconGrid = new TextureAtlasSprite[this.iconGridCountX * this.iconGridCountY];
            this.iconGridSizeU = 1.0 / this.iconGridCountX;
            this.iconGridSizeV = 1.0 / this.iconGridCountY;
            for (final TextureAtlasSprite textureatlassprite : this.mapUploadedSprites.values()) {
                final double d0 = 0.5 / p_updateIconGrid_1_;
                final double d2 = 0.5 / p_updateIconGrid_2_;
                final double d3 = Math.min(textureatlassprite.getMinU(), textureatlassprite.getMaxU()) + d0;
                final double d4 = Math.min(textureatlassprite.getMinV(), textureatlassprite.getMaxV()) + d2;
                final double d5 = Math.max(textureatlassprite.getMinU(), textureatlassprite.getMaxU()) - d0;
                final double d6 = Math.max(textureatlassprite.getMinV(), textureatlassprite.getMaxV()) - d2;
                final int i = (int)(d3 / this.iconGridSizeU);
                final int j = (int)(d4 / this.iconGridSizeV);
                final int k = (int)(d5 / this.iconGridSizeU);
                final int l = (int)(d6 / this.iconGridSizeV);
                for (int i2 = i; i2 <= k; ++i2) {
                    if (i2 >= 0 && i2 < this.iconGridCountX) {
                        for (int j2 = j; j2 <= l; ++j2) {
                            if (j2 >= 0 && j2 < this.iconGridCountX) {
                                final int k2 = j2 * this.iconGridCountX + i2;
                                this.iconGrid[k2] = textureatlassprite;
                            }
                            else {
                                Config.warn("Invalid grid V: " + j2 + ", icon: " + textureatlassprite.getIconName());
                            }
                        }
                    }
                    else {
                        Config.warn("Invalid grid U: " + i2 + ", icon: " + textureatlassprite.getIconName());
                    }
                }
            }
        }
    }
    
    public TextureAtlasSprite getIconByUV(final double p_getIconByUV_1_, final double p_getIconByUV_3_) {
        if (this.iconGrid == null) {
            return null;
        }
        final int i = (int)(p_getIconByUV_1_ / this.iconGridSizeU);
        final int j = (int)(p_getIconByUV_3_ / this.iconGridSizeV);
        final int k = j * this.iconGridCountX + i;
        return (k >= 0 && k <= this.iconGrid.length) ? this.iconGrid[k] : null;
    }
}
