// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.enchantment;

import net.minecraft.item.ItemSkull;
import net.minecraft.item.ItemElytra;
import net.minecraft.block.BlockPumpkin;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemFishingRod;
import net.minecraft.item.ItemTool;
import net.minecraft.item.ItemSword;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;

public enum EnumEnchantmentType
{
    ALL(0) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            EnumEnchantmentType[] values;
            for (int length = (values = EnumEnchantmentType.values()).length, i = 0; i < length; ++i) {
                final EnumEnchantmentType enumenchantmenttype = values[i];
                if (enumenchantmenttype != EnumEnchantmentType.ALL && enumenchantmenttype.canEnchantItem(itemIn)) {
                    return true;
                }
            }
            return false;
        }
    }, 
    ARMOR(1) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemArmor;
        }
    }, 
    ARMOR_FEET(2) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemArmor && ((ItemArmor)itemIn).armorType == EntityEquipmentSlot.FEET;
        }
    }, 
    ARMOR_LEGS(3) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemArmor && ((ItemArmor)itemIn).armorType == EntityEquipmentSlot.LEGS;
        }
    }, 
    ARMOR_CHEST(4) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemArmor && ((ItemArmor)itemIn).armorType == EntityEquipmentSlot.CHEST;
        }
    }, 
    ARMOR_HEAD(5) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemArmor && ((ItemArmor)itemIn).armorType == EntityEquipmentSlot.HEAD;
        }
    }, 
    WEAPON(6) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemSword;
        }
    }, 
    DIGGER(7) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemTool;
        }
    }, 
    FISHING_ROD(8) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemFishingRod;
        }
    }, 
    BREAKABLE(9) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn.isDamageable();
        }
    }, 
    BOW(10) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            return itemIn instanceof ItemBow;
        }
    }, 
    WEARABLE(11) {
        @Override
        public boolean canEnchantItem(final Item itemIn) {
            final boolean flag = itemIn instanceof ItemBlock && ((ItemBlock)itemIn).getBlock() instanceof BlockPumpkin;
            return itemIn instanceof ItemArmor || itemIn instanceof ItemElytra || itemIn instanceof ItemSkull || flag;
        }
    };
    
    private EnumEnchantmentType(final String name, final int ordinal) {
    }
    
    public abstract boolean canEnchantItem(final Item p0);
}
