// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.entity.monster;

import net.minecraft.entity.IEntityLivingData;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.block.state.IBlockState;
import net.minecraft.world.IBlockAccess;
import net.minecraft.entity.projectile.EntityEvokerFangs;
import net.minecraft.util.math.BlockPos;
import java.util.List;
import net.minecraft.item.EnumDyeColor;
import com.google.common.base.Predicate;
import java.util.Random;
import net.minecraft.pathfinding.PathNavigate;
import javax.annotation.Nullable;
import net.minecraft.init.SoundEvents;
import net.minecraft.util.SoundEvent;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.storage.loot.LootTableList;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.datafix.DataFixer;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.world.World;
import net.minecraft.entity.Entity;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.network.datasync.DataParameter;

public class EntityEvoker extends EntityMob
{
    protected static final DataParameter<Byte> field_190760_a;
    private int field_190761_b;
    private int field_190762_c;
    private EntitySheep field_190763_bw;
    
    static {
        field_190760_a = EntityDataManager.createKey(EntityEvoker.class, DataSerializers.BYTE);
    }
    
    public EntityEvoker(final World p_i47287_1_) {
        super(p_i47287_1_);
        this.setSize(0.6f, 1.95f);
        this.experienceValue = 10;
    }
    
    @Override
    protected void initEntityAI() {
        super.initEntityAI();
        this.tasks.addTask(0, new EntityAISwimming(this));
        this.tasks.addTask(1, new AICastingSpell());
        this.tasks.addTask(2, new EntityAIAvoidEntity<Object>(this, EntityPlayer.class, 8.0f, 0.6, 1.0));
        this.tasks.addTask(4, new AISummonSpell((AISummonSpell)null));
        this.tasks.addTask(5, new AIAttackSpell((AIAttackSpell)null));
        this.tasks.addTask(6, new AIWololoSpell());
        this.tasks.addTask(8, new EntityAIWander(this, 0.6));
        this.tasks.addTask(9, new EntityAIWatchClosest(this, EntityPlayer.class, 3.0f, 1.0f));
        this.tasks.addTask(10, new EntityAIWatchClosest(this, EntityLiving.class, 8.0f));
        this.targetTasks.addTask(1, new EntityAIHurtByTarget(this, true, (Class<?>[])new Class[] { EntityEvoker.class }));
        this.targetTasks.addTask(2, new EntityAINearestAttackableTarget<Object>(this, EntityPlayer.class, true).func_190882_b(300));
        this.targetTasks.addTask(3, new EntityAINearestAttackableTarget<Object>(this, EntityVillager.class, false).func_190882_b(300));
        this.targetTasks.addTask(3, new EntityAINearestAttackableTarget<Object>(this, EntityIronGolem.class, false));
    }
    
    @Override
    protected void applyEntityAttributes() {
        super.applyEntityAttributes();
        this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.5);
        this.getEntityAttribute(SharedMonsterAttributes.FOLLOW_RANGE).setBaseValue(12.0);
        this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(24.0);
    }
    
    @Override
    protected void entityInit() {
        super.entityInit();
        this.dataManager.register(EntityEvoker.field_190760_a, (Byte)0);
    }
    
    public static void func_190759_b(final DataFixer p_190759_0_) {
        EntityLiving.registerFixesMob(p_190759_0_, EntityEvoker.class);
    }
    
    @Override
    public void readEntityFromNBT(final NBTTagCompound compound) {
        super.readEntityFromNBT(compound);
        this.field_190761_b = compound.getInteger("SpellTicks");
    }
    
    @Override
    public void writeEntityToNBT(final NBTTagCompound compound) {
        super.writeEntityToNBT(compound);
        compound.setInteger("SpellTicks", this.field_190761_b);
    }
    
    @Override
    public EnumCreatureAttribute getCreatureAttribute() {
        return EnumCreatureAttribute.ILLAGER;
    }
    
    @Override
    protected ResourceLocation getLootTable() {
        return LootTableList.field_191185_au;
    }
    
    public boolean func_190749_o() {
        return this.world.isRemote ? (this.dataManager.get(EntityEvoker.field_190760_a) > 0) : (this.field_190761_b > 0);
    }
    
    public void func_190753_a(final int p_190753_1_) {
        this.dataManager.set(EntityEvoker.field_190760_a, (byte)p_190753_1_);
    }
    
    private int func_190755_di() {
        return this.field_190761_b;
    }
    
    @Override
    protected void updateAITasks() {
        super.updateAITasks();
        if (this.field_190761_b > 0) {
            --this.field_190761_b;
        }
    }
    
    @Override
    public void onUpdate() {
        super.onUpdate();
        if (this.world.isRemote && this.func_190749_o()) {
            final int i = this.dataManager.get(EntityEvoker.field_190760_a);
            double d0 = 0.7;
            double d2 = 0.5;
            double d3 = 0.2;
            if (i == 2) {
                d0 = 0.4;
                d2 = 0.3;
                d3 = 0.35;
            }
            else if (i == 1) {
                d0 = 0.7;
                d2 = 0.7;
                d3 = 0.8;
            }
            final float f = this.renderYawOffset * 0.017453292f + MathHelper.cos(this.ticksExisted * 0.6662f) * 0.25f;
            final float f2 = MathHelper.cos(f);
            final float f3 = MathHelper.sin(f);
            this.world.spawnParticle(EnumParticleTypes.SPELL_MOB, this.posX + f2 * 0.6, this.posY + 1.8, this.posZ + f3 * 0.6, d0, d2, d3, new int[0]);
            this.world.spawnParticle(EnumParticleTypes.SPELL_MOB, this.posX - f2 * 0.6, this.posY + 1.8, this.posZ - f3 * 0.6, d0, d2, d3, new int[0]);
        }
    }
    
    @Override
    public boolean isOnSameTeam(final Entity entityIn) {
        return entityIn != null && (entityIn == this || super.isOnSameTeam(entityIn) || ((entityIn instanceof EntityVex) ? this.isOnSameTeam(((EntityVex)entityIn).func_190645_o()) : (entityIn instanceof EntityLivingBase && ((EntityLivingBase)entityIn).getCreatureAttribute() == EnumCreatureAttribute.ILLAGER && (this.getTeam() == null && entityIn.getTeam() == null))));
    }
    
    @Override
    protected SoundEvent getAmbientSound() {
        return SoundEvents.field_191243_bm;
    }
    
    @Override
    protected SoundEvent getDeathSound() {
        return SoundEvents.field_191245_bo;
    }
    
    @Override
    protected SoundEvent getHurtSound() {
        return SoundEvents.field_191246_bp;
    }
    
    private void func_190748_a(@Nullable final EntitySheep p_190748_1_) {
        this.field_190763_bw = p_190748_1_;
    }
    
    @Nullable
    private EntitySheep func_190751_dj() {
        return this.field_190763_bw;
    }
    
    static /* synthetic */ void access$5(final EntityEvoker entityEvoker, final int field_190761_b) {
        entityEvoker.field_190761_b = field_190761_b;
    }
    
    static /* synthetic */ void access$6(final EntityEvoker entityEvoker, final int field_190762_c) {
        entityEvoker.field_190762_c = field_190762_c;
    }
    
    public class AIWololoSpell extends AIUseSpell
    {
        final Predicate<EntitySheep> field_190879_a;
        
        public AIWololoSpell() {
            super((AIUseSpell)null);
            this.field_190879_a = (Predicate<EntitySheep>)new Predicate<EntitySheep>() {
                public boolean apply(final EntitySheep p_apply_1_) {
                    return p_apply_1_.getFleeceColor() == EnumDyeColor.BLUE;
                }
            };
        }
        
        @Override
        public boolean shouldExecute() {
            if (EntityEvoker.this.getAttackTarget() != null) {
                return false;
            }
            if (EntityEvoker.this.func_190749_o()) {
                return false;
            }
            if (EntityEvoker.this.ticksExisted < this.field_190874_c) {
                return false;
            }
            if (!EntityEvoker.this.world.getGameRules().getBoolean("mobGriefing")) {
                return false;
            }
            final List<EntitySheep> list = EntityEvoker.this.world.getEntitiesWithinAABB((Class<? extends EntitySheep>)EntitySheep.class, EntityEvoker.this.getEntityBoundingBox().expand(16.0, 4.0, 16.0), (com.google.common.base.Predicate<? super EntitySheep>)this.field_190879_a);
            if (list.isEmpty()) {
                return false;
            }
            EntityEvoker.this.func_190748_a(list.get(EntityEvoker.this.rand.nextInt(list.size())));
            return true;
        }
        
        @Override
        public boolean continueExecuting() {
            return EntityEvoker.this.func_190751_dj() != null && this.field_190873_b > 0;
        }
        
        @Override
        public void resetTask() {
            super.resetTask();
            EntityEvoker.this.func_190748_a(null);
        }
        
        @Override
        protected void func_190868_j() {
            final EntitySheep entitysheep = EntityEvoker.this.func_190751_dj();
            if (entitysheep != null && entitysheep.isEntityAlive()) {
                entitysheep.setFleeceColor(EnumDyeColor.RED);
            }
        }
        
        @Override
        protected int func_190867_m() {
            return 40;
        }
        
        @Override
        protected int func_190869_f() {
            return 60;
        }
        
        @Override
        protected int func_190872_i() {
            return 140;
        }
        
        @Override
        protected SoundEvent func_190871_k() {
            return SoundEvents.field_191249_bs;
        }
        
        @Override
        protected int func_190870_l() {
            return 3;
        }
    }
    
    class AIAttackSpell extends AIUseSpell
    {
        private AIAttackSpell() {
            super((AIUseSpell)null);
        }
        
        @Override
        protected int func_190869_f() {
            return 40;
        }
        
        @Override
        protected int func_190872_i() {
            return 100;
        }
        
        @Override
        protected void func_190868_j() {
            final EntityLivingBase entitylivingbase = EntityEvoker.this.getAttackTarget();
            final double d0 = Math.min(entitylivingbase.posY, EntityEvoker.this.posY);
            final double d2 = Math.max(entitylivingbase.posY, EntityEvoker.this.posY) + 1.0;
            final float f = (float)MathHelper.atan2(entitylivingbase.posZ - EntityEvoker.this.posZ, entitylivingbase.posX - EntityEvoker.this.posX);
            if (EntityEvoker.this.getDistanceSqToEntity(entitylivingbase) < 9.0) {
                for (int i = 0; i < 5; ++i) {
                    final float f2 = f + i * 3.1415927f * 0.4f;
                    this.func_190876_a(EntityEvoker.this.posX + MathHelper.cos(f2) * 1.5, EntityEvoker.this.posZ + MathHelper.sin(f2) * 1.5, d0, d2, f2, 0);
                }
                for (int k = 0; k < 8; ++k) {
                    final float f3 = f + k * 3.1415927f * 2.0f / 8.0f + 1.2566371f;
                    this.func_190876_a(EntityEvoker.this.posX + MathHelper.cos(f3) * 2.5, EntityEvoker.this.posZ + MathHelper.sin(f3) * 2.5, d0, d2, f3, 3);
                }
            }
            else {
                for (int l = 0; l < 16; ++l) {
                    final double d3 = 1.25 * (l + 1);
                    final int j = 1 * l;
                    this.func_190876_a(EntityEvoker.this.posX + MathHelper.cos(f) * d3, EntityEvoker.this.posZ + MathHelper.sin(f) * d3, d0, d2, f, j);
                }
            }
        }
        
        private void func_190876_a(final double p_190876_1_, final double p_190876_3_, final double p_190876_5_, final double p_190876_7_, final float p_190876_9_, final int p_190876_10_) {
            BlockPos blockpos = new BlockPos(p_190876_1_, p_190876_7_, p_190876_3_);
            boolean flag = false;
            double d0 = 0.0;
            while (true) {
                while (EntityEvoker.this.world.isBlockNormalCube(blockpos, true) || !EntityEvoker.this.world.isBlockNormalCube(blockpos.down(), true)) {
                    blockpos = blockpos.down();
                    if (blockpos.getY() < MathHelper.floor(p_190876_5_) - 1) {
                        if (flag) {
                            final EntityEvokerFangs entityevokerfangs = new EntityEvokerFangs(EntityEvoker.this.world, p_190876_1_, blockpos.getY() + d0, p_190876_3_, p_190876_9_, p_190876_10_, EntityEvoker.this);
                            EntityEvoker.this.world.spawnEntityInWorld(entityevokerfangs);
                        }
                        return;
                    }
                }
                if (!EntityEvoker.this.world.isAirBlock(blockpos)) {
                    final IBlockState iblockstate = EntityEvoker.this.world.getBlockState(blockpos);
                    final AxisAlignedBB axisalignedbb = iblockstate.getCollisionBoundingBox(EntityEvoker.this.world, blockpos);
                    if (axisalignedbb != null) {
                        d0 = axisalignedbb.maxY;
                    }
                }
                flag = true;
                continue;
            }
        }
        
        @Override
        protected SoundEvent func_190871_k() {
            return SoundEvents.field_191247_bq;
        }
        
        @Override
        protected int func_190870_l() {
            return 2;
        }
    }
    
    class AICastingSpell extends EntityAIBase
    {
        public AICastingSpell() {
            this.setMutexBits(3);
        }
        
        @Override
        public boolean shouldExecute() {
            return EntityEvoker.this.func_190755_di() > 0;
        }
        
        @Override
        public void startExecuting() {
            super.startExecuting();
            EntityEvoker.this.func_190753_a(EntityEvoker.this.field_190762_c);
            EntityEvoker.this.navigator.clearPathEntity();
        }
        
        @Override
        public void resetTask() {
            super.resetTask();
            EntityEvoker.this.func_190753_a(0);
        }
        
        @Override
        public void updateTask() {
            if (EntityEvoker.this.getAttackTarget() != null) {
                EntityEvoker.this.getLookHelper().setLookPositionWithEntity(EntityEvoker.this.getAttackTarget(), (float)EntityEvoker.this.getHorizontalFaceSpeed(), (float)EntityEvoker.this.getVerticalFaceSpeed());
            }
            else if (EntityEvoker.this.func_190751_dj() != null) {
                EntityEvoker.this.getLookHelper().setLookPositionWithEntity(EntityEvoker.this.func_190751_dj(), (float)EntityEvoker.this.getHorizontalFaceSpeed(), (float)EntityEvoker.this.getVerticalFaceSpeed());
            }
        }
    }
    
    class AISummonSpell extends AIUseSpell
    {
        private AISummonSpell() {
            super((AIUseSpell)null);
        }
        
        @Override
        public boolean shouldExecute() {
            if (!super.shouldExecute()) {
                return false;
            }
            final int i = EntityEvoker.this.world.getEntitiesWithinAABB((Class<? extends Entity>)EntityVex.class, EntityEvoker.this.getEntityBoundingBox().expandXyz(16.0)).size();
            return EntityEvoker.this.rand.nextInt(8) + 1 > i;
        }
        
        @Override
        protected int func_190869_f() {
            return 100;
        }
        
        @Override
        protected int func_190872_i() {
            return 340;
        }
        
        @Override
        protected void func_190868_j() {
            for (int i = 0; i < 3; ++i) {
                final BlockPos blockpos = new BlockPos(EntityEvoker.this).add(-2 + EntityEvoker.this.rand.nextInt(5), 1, -2 + EntityEvoker.this.rand.nextInt(5));
                final EntityVex entityvex = new EntityVex(EntityEvoker.this.world);
                entityvex.moveToBlockPosAndAngles(blockpos, 0.0f, 0.0f);
                entityvex.onInitialSpawn(EntityEvoker.this.world.getDifficultyForLocation(blockpos), null);
                entityvex.func_190658_a(EntityEvoker.this);
                entityvex.func_190651_g(blockpos);
                entityvex.func_190653_a(20 * (30 + EntityEvoker.this.rand.nextInt(90)));
                EntityEvoker.this.world.spawnEntityInWorld(entityvex);
            }
        }
        
        @Override
        protected SoundEvent func_190871_k() {
            return SoundEvents.field_191248_br;
        }
        
        @Override
        protected int func_190870_l() {
            return 1;
        }
    }
    
    abstract class AIUseSpell extends EntityAIBase
    {
        protected int field_190873_b;
        protected int field_190874_c;
        
        private AIUseSpell() {
        }
        
        @Override
        public boolean shouldExecute() {
            return EntityEvoker.this.getAttackTarget() != null && !EntityEvoker.this.func_190749_o() && EntityEvoker.this.ticksExisted >= this.field_190874_c;
        }
        
        @Override
        public boolean continueExecuting() {
            return EntityEvoker.this.getAttackTarget() != null && this.field_190873_b > 0;
        }
        
        @Override
        public void startExecuting() {
            this.field_190873_b = this.func_190867_m();
            EntityEvoker.access$5(EntityEvoker.this, this.func_190869_f());
            this.field_190874_c = EntityEvoker.this.ticksExisted + this.func_190872_i();
            EntityEvoker.this.playSound(this.func_190871_k(), 1.0f, 1.0f);
            EntityEvoker.access$6(EntityEvoker.this, this.func_190870_l());
        }
        
        @Override
        public void updateTask() {
            --this.field_190873_b;
            if (this.field_190873_b == 0) {
                this.func_190868_j();
                EntityEvoker.this.playSound(SoundEvents.field_191244_bn, 1.0f, 1.0f);
            }
        }
        
        protected abstract void func_190868_j();
        
        protected int func_190867_m() {
            return 20;
        }
        
        protected abstract int func_190869_f();
        
        protected abstract int func_190872_i();
        
        protected abstract SoundEvent func_190871_k();
        
        protected abstract int func_190870_l();
    }
}
