// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.inventory;

import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.MathHelper;
import net.minecraft.item.Item;
import java.util.Iterator;
import net.minecraft.entity.player.InventoryPlayer;
import javax.annotation.Nullable;
import com.google.common.collect.Sets;
import com.google.common.collect.Lists;
import net.minecraft.entity.player.EntityPlayer;
import java.util.Set;
import java.util.List;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;

public abstract class Container
{
    public NonNullList<ItemStack> inventoryItemStacks;
    public List<Slot> inventorySlots;
    public int windowId;
    private short transactionID;
    private int dragMode;
    private int dragEvent;
    private final Set<Slot> dragSlots;
    protected List<IContainerListener> listeners;
    private final Set<EntityPlayer> playerList;
    
    public Container() {
        this.inventoryItemStacks = NonNullList.func_191196_a();
        this.inventorySlots = (List<Slot>)Lists.newArrayList();
        this.dragMode = -1;
        this.dragSlots = (Set<Slot>)Sets.newHashSet();
        this.listeners = (List<IContainerListener>)Lists.newArrayList();
        this.playerList = (Set<EntityPlayer>)Sets.newHashSet();
    }
    
    protected Slot addSlotToContainer(final Slot slotIn) {
        slotIn.slotNumber = this.inventorySlots.size();
        this.inventorySlots.add(slotIn);
        this.inventoryItemStacks.add(ItemStack.field_190927_a);
        return slotIn;
    }
    
    public void addListener(final IContainerListener listener) {
        if (this.listeners.contains(listener)) {
            throw new IllegalArgumentException("Listener already listening");
        }
        this.listeners.add(listener);
        listener.updateCraftingInventory(this, this.getInventory());
        this.detectAndSendChanges();
    }
    
    public void removeListener(final IContainerListener listener) {
        this.listeners.remove(listener);
    }
    
    public NonNullList<ItemStack> getInventory() {
        final NonNullList<ItemStack> nonnulllist = NonNullList.func_191196_a();
        for (int i = 0; i < this.inventorySlots.size(); ++i) {
            nonnulllist.add(this.inventorySlots.get(i).getStack());
        }
        return nonnulllist;
    }
    
    public void detectAndSendChanges() {
        for (int i = 0; i < this.inventorySlots.size(); ++i) {
            final ItemStack itemstack = this.inventorySlots.get(i).getStack();
            ItemStack itemstack2 = this.inventoryItemStacks.get(i);
            if (!ItemStack.areItemStacksEqual(itemstack2, itemstack)) {
                itemstack2 = (itemstack.func_190926_b() ? ItemStack.field_190927_a : itemstack.copy());
                this.inventoryItemStacks.set(i, itemstack2);
                for (int j = 0; j < this.listeners.size(); ++j) {
                    this.listeners.get(j).sendSlotContents(this, i, itemstack2);
                }
            }
        }
    }
    
    public boolean enchantItem(final EntityPlayer playerIn, final int id) {
        return false;
    }
    
    @Nullable
    public Slot getSlotFromInventory(final IInventory inv, final int slotIn) {
        for (int i = 0; i < this.inventorySlots.size(); ++i) {
            final Slot slot = this.inventorySlots.get(i);
            if (slot.isHere(inv, slotIn)) {
                return slot;
            }
        }
        return null;
    }
    
    public Slot getSlot(final int slotId) {
        return this.inventorySlots.get(slotId);
    }
    
    public ItemStack transferStackInSlot(final EntityPlayer playerIn, final int index) {
        final Slot slot = this.inventorySlots.get(index);
        return (slot != null) ? slot.getStack() : ItemStack.field_190927_a;
    }
    
    public ItemStack slotClick(final int slotId, final int dragType, final ClickType clickTypeIn, final EntityPlayer player) {
        ItemStack itemstack = ItemStack.field_190927_a;
        final InventoryPlayer inventoryplayer = player.inventory;
        if (clickTypeIn == ClickType.QUICK_CRAFT) {
            final int i = this.dragEvent;
            this.dragEvent = getDragEvent(dragType);
            if ((i != 1 || this.dragEvent != 2) && i != this.dragEvent) {
                this.resetDrag();
            }
            else if (inventoryplayer.getItemStack().func_190926_b()) {
                this.resetDrag();
            }
            else if (this.dragEvent == 0) {
                this.dragMode = extractDragMode(dragType);
                if (isValidDragMode(this.dragMode, player)) {
                    this.dragEvent = 1;
                    this.dragSlots.clear();
                }
                else {
                    this.resetDrag();
                }
            }
            else if (this.dragEvent == 1) {
                final Slot slot = this.inventorySlots.get(slotId);
                final ItemStack itemstack2 = inventoryplayer.getItemStack();
                if (slot != null && canAddItemToSlot(slot, itemstack2, true) && slot.isItemValid(itemstack2) && (this.dragMode == 2 || itemstack2.func_190916_E() > this.dragSlots.size()) && this.canDragIntoSlot(slot)) {
                    this.dragSlots.add(slot);
                }
            }
            else if (this.dragEvent == 2) {
                if (!this.dragSlots.isEmpty()) {
                    final ItemStack itemstack3 = inventoryplayer.getItemStack().copy();
                    int l = inventoryplayer.getItemStack().func_190916_E();
                    for (final Slot slot2 : this.dragSlots) {
                        final ItemStack itemstack4 = inventoryplayer.getItemStack();
                        if (slot2 != null && canAddItemToSlot(slot2, itemstack4, true) && slot2.isItemValid(itemstack4) && (this.dragMode == 2 || itemstack4.func_190916_E() >= this.dragSlots.size()) && this.canDragIntoSlot(slot2)) {
                            final ItemStack itemstack5 = itemstack3.copy();
                            final int j = slot2.getHasStack() ? slot2.getStack().func_190916_E() : 0;
                            computeStackSize(this.dragSlots, this.dragMode, itemstack5, j);
                            final int k = Math.min(itemstack5.getMaxStackSize(), slot2.getItemStackLimit(itemstack5));
                            if (itemstack5.func_190916_E() > k) {
                                itemstack5.func_190920_e(k);
                            }
                            l -= itemstack5.func_190916_E() - j;
                            slot2.putStack(itemstack5);
                        }
                    }
                    itemstack3.func_190920_e(l);
                    inventoryplayer.setItemStack(itemstack3);
                }
                this.resetDrag();
            }
            else {
                this.resetDrag();
            }
        }
        else if (this.dragEvent != 0) {
            this.resetDrag();
        }
        else if ((clickTypeIn == ClickType.PICKUP || clickTypeIn == ClickType.QUICK_MOVE) && (dragType == 0 || dragType == 1)) {
            if (slotId == -999) {
                if (!inventoryplayer.getItemStack().func_190926_b()) {
                    if (dragType == 0) {
                        player.dropItem(inventoryplayer.getItemStack(), true);
                        inventoryplayer.setItemStack(ItemStack.field_190927_a);
                    }
                    if (dragType == 1) {
                        player.dropItem(inventoryplayer.getItemStack().splitStack(1), true);
                    }
                }
            }
            else if (clickTypeIn == ClickType.QUICK_MOVE) {
                if (slotId < 0) {
                    return ItemStack.field_190927_a;
                }
                final Slot slot3 = this.inventorySlots.get(slotId);
                if (slot3 != null && slot3.canTakeStack(player)) {
                    final ItemStack itemstack6 = this.transferStackInSlot(player, slotId);
                    if (!itemstack6.func_190926_b()) {
                        final Item item = itemstack6.getItem();
                        itemstack = itemstack6.copy();
                        if (slot3.getStack().getItem() == item) {
                            this.retrySlotClick(slotId, dragType, true, player);
                        }
                    }
                }
            }
            else {
                if (slotId < 0) {
                    return ItemStack.field_190927_a;
                }
                final Slot slot4 = this.inventorySlots.get(slotId);
                if (slot4 != null) {
                    ItemStack itemstack7 = slot4.getStack();
                    final ItemStack itemstack8 = inventoryplayer.getItemStack();
                    if (!itemstack7.func_190926_b()) {
                        itemstack = itemstack7.copy();
                    }
                    if (itemstack7.func_190926_b()) {
                        if (!itemstack8.func_190926_b() && slot4.isItemValid(itemstack8)) {
                            int l2 = (dragType == 0) ? itemstack8.func_190916_E() : 1;
                            if (l2 > slot4.getItemStackLimit(itemstack8)) {
                                l2 = slot4.getItemStackLimit(itemstack8);
                            }
                            slot4.putStack(itemstack8.splitStack(l2));
                        }
                    }
                    else if (slot4.canTakeStack(player)) {
                        if (itemstack8.func_190926_b()) {
                            if (itemstack7.func_190926_b()) {
                                slot4.putStack(ItemStack.field_190927_a);
                                inventoryplayer.setItemStack(ItemStack.field_190927_a);
                            }
                            else {
                                final int k2 = (dragType == 0) ? itemstack7.func_190916_E() : ((itemstack7.func_190916_E() + 1) / 2);
                                inventoryplayer.setItemStack(slot4.decrStackSize(k2));
                                if (itemstack7.func_190926_b()) {
                                    slot4.putStack(ItemStack.field_190927_a);
                                }
                                slot4.func_190901_a(player, inventoryplayer.getItemStack());
                            }
                        }
                        else if (slot4.isItemValid(itemstack8)) {
                            if (itemstack7.getItem() == itemstack8.getItem() && itemstack7.getMetadata() == itemstack8.getMetadata() && ItemStack.areItemStackTagsEqual(itemstack7, itemstack8)) {
                                int j2 = (dragType == 0) ? itemstack8.func_190916_E() : 1;
                                if (j2 > slot4.getItemStackLimit(itemstack8) - itemstack7.func_190916_E()) {
                                    j2 = slot4.getItemStackLimit(itemstack8) - itemstack7.func_190916_E();
                                }
                                if (j2 > itemstack8.getMaxStackSize() - itemstack7.func_190916_E()) {
                                    j2 = itemstack8.getMaxStackSize() - itemstack7.func_190916_E();
                                }
                                itemstack8.func_190918_g(j2);
                                itemstack7.func_190917_f(j2);
                            }
                            else if (itemstack8.func_190916_E() <= slot4.getItemStackLimit(itemstack8)) {
                                slot4.putStack(itemstack8);
                                inventoryplayer.setItemStack(itemstack7);
                            }
                        }
                        else if (itemstack7.getItem() == itemstack8.getItem() && itemstack8.getMaxStackSize() > 1 && (!itemstack7.getHasSubtypes() || itemstack7.getMetadata() == itemstack8.getMetadata()) && ItemStack.areItemStackTagsEqual(itemstack7, itemstack8) && !itemstack7.func_190926_b()) {
                            final int i2 = itemstack7.func_190916_E();
                            if (i2 + itemstack8.func_190916_E() <= itemstack8.getMaxStackSize()) {
                                itemstack8.func_190917_f(i2);
                                itemstack7 = slot4.decrStackSize(i2);
                                if (itemstack7.func_190926_b()) {
                                    slot4.putStack(ItemStack.field_190927_a);
                                }
                                slot4.func_190901_a(player, inventoryplayer.getItemStack());
                            }
                        }
                    }
                    slot4.onSlotChanged();
                }
            }
        }
        else if (clickTypeIn == ClickType.SWAP && dragType >= 0 && dragType < 9) {
            final Slot slot5 = this.inventorySlots.get(slotId);
            final ItemStack itemstack9 = inventoryplayer.getStackInSlot(dragType);
            final ItemStack itemstack10 = slot5.getStack();
            if (!itemstack9.func_190926_b() || !itemstack10.func_190926_b()) {
                if (itemstack9.func_190926_b()) {
                    if (slot5.canTakeStack(player)) {
                        inventoryplayer.setInventorySlotContents(dragType, itemstack10);
                        slot5.func_190900_b(itemstack10.func_190916_E());
                        slot5.putStack(ItemStack.field_190927_a);
                        slot5.func_190901_a(player, itemstack10);
                    }
                }
                else if (itemstack10.func_190926_b()) {
                    if (slot5.isItemValid(itemstack9)) {
                        final int k3 = slot5.getItemStackLimit(itemstack9);
                        if (itemstack9.func_190916_E() > k3) {
                            slot5.putStack(itemstack9.splitStack(k3));
                        }
                        else {
                            slot5.putStack(itemstack9);
                            inventoryplayer.setInventorySlotContents(dragType, ItemStack.field_190927_a);
                        }
                    }
                }
                else if (slot5.canTakeStack(player) && slot5.isItemValid(itemstack9)) {
                    final int l3 = slot5.getItemStackLimit(itemstack9);
                    if (itemstack9.func_190916_E() > l3) {
                        slot5.putStack(itemstack9.splitStack(l3));
                        slot5.func_190901_a(player, itemstack10);
                        if (!inventoryplayer.addItemStackToInventory(itemstack10)) {
                            player.dropItem(itemstack10, true);
                        }
                    }
                    else {
                        slot5.putStack(itemstack9);
                        inventoryplayer.setInventorySlotContents(dragType, itemstack10);
                        slot5.func_190901_a(player, itemstack10);
                    }
                }
            }
        }
        else if (clickTypeIn == ClickType.CLONE && player.capabilities.isCreativeMode && inventoryplayer.getItemStack().func_190926_b() && slotId >= 0) {
            final Slot slot6 = this.inventorySlots.get(slotId);
            if (slot6 != null && slot6.getHasStack()) {
                final ItemStack itemstack11 = slot6.getStack().copy();
                itemstack11.func_190920_e(itemstack11.getMaxStackSize());
                inventoryplayer.setItemStack(itemstack11);
            }
        }
        else if (clickTypeIn == ClickType.THROW && inventoryplayer.getItemStack().func_190926_b() && slotId >= 0) {
            final Slot slot7 = this.inventorySlots.get(slotId);
            if (slot7 != null && slot7.getHasStack() && slot7.canTakeStack(player)) {
                final ItemStack itemstack12 = slot7.decrStackSize((dragType == 0) ? 1 : slot7.getStack().func_190916_E());
                slot7.func_190901_a(player, itemstack12);
                player.dropItem(itemstack12, true);
            }
        }
        else if (clickTypeIn == ClickType.PICKUP_ALL && slotId >= 0) {
            final Slot slot8 = this.inventorySlots.get(slotId);
            final ItemStack itemstack13 = inventoryplayer.getItemStack();
            if (!itemstack13.func_190926_b() && (slot8 == null || !slot8.getHasStack() || !slot8.canTakeStack(player))) {
                final int i3 = (dragType == 0) ? 0 : (this.inventorySlots.size() - 1);
                final int j3 = (dragType == 0) ? 1 : -1;
                for (int i4 = 0; i4 < 2; ++i4) {
                    for (int j4 = i3; j4 >= 0 && j4 < this.inventorySlots.size() && itemstack13.func_190916_E() < itemstack13.getMaxStackSize(); j4 += j3) {
                        final Slot slot9 = this.inventorySlots.get(j4);
                        if (slot9.getHasStack() && canAddItemToSlot(slot9, itemstack13, true) && slot9.canTakeStack(player) && this.canMergeSlot(itemstack13, slot9)) {
                            final ItemStack itemstack14 = slot9.getStack();
                            if (i4 != 0 || itemstack14.func_190916_E() != itemstack14.getMaxStackSize()) {
                                final int k4 = Math.min(itemstack13.getMaxStackSize() - itemstack13.func_190916_E(), itemstack14.func_190916_E());
                                final ItemStack itemstack15 = slot9.decrStackSize(k4);
                                itemstack13.func_190917_f(k4);
                                if (itemstack15.func_190926_b()) {
                                    slot9.putStack(ItemStack.field_190927_a);
                                }
                                slot9.func_190901_a(player, itemstack15);
                            }
                        }
                    }
                }
            }
            this.detectAndSendChanges();
        }
        return itemstack;
    }
    
    public boolean canMergeSlot(final ItemStack stack, final Slot slotIn) {
        return true;
    }
    
    protected void retrySlotClick(final int slotId, final int clickedButton, final boolean mode, final EntityPlayer playerIn) {
        this.slotClick(slotId, clickedButton, ClickType.QUICK_MOVE, playerIn);
    }
    
    public void onContainerClosed(final EntityPlayer playerIn) {
        final InventoryPlayer inventoryplayer = playerIn.inventory;
        if (!inventoryplayer.getItemStack().func_190926_b()) {
            playerIn.dropItem(inventoryplayer.getItemStack(), false);
            inventoryplayer.setItemStack(ItemStack.field_190927_a);
        }
    }
    
    public void onCraftMatrixChanged(final IInventory inventoryIn) {
        this.detectAndSendChanges();
    }
    
    public void putStackInSlot(final int slotID, final ItemStack stack) {
        this.getSlot(slotID).putStack(stack);
    }
    
    public void func_190896_a(final List<ItemStack> p_190896_1_) {
        for (int i = 0; i < p_190896_1_.size(); ++i) {
            this.getSlot(i).putStack(p_190896_1_.get(i));
        }
    }
    
    public void updateProgressBar(final int id, final int data) {
    }
    
    public short getNextTransactionID(final InventoryPlayer invPlayer) {
        return (short)(++this.transactionID);
    }
    
    public boolean getCanCraft(final EntityPlayer player) {
        return !this.playerList.contains(player);
    }
    
    public void setCanCraft(final EntityPlayer player, final boolean canCraft) {
        if (canCraft) {
            this.playerList.remove(player);
        }
        else {
            this.playerList.add(player);
        }
    }
    
    public abstract boolean canInteractWith(final EntityPlayer p0);
    
    protected boolean mergeItemStack(final ItemStack stack, final int startIndex, final int endIndex, final boolean reverseDirection) {
        boolean flag = false;
        int i = startIndex;
        if (reverseDirection) {
            i = endIndex - 1;
        }
        if (stack.isStackable()) {
            while (!stack.func_190926_b()) {
                if (reverseDirection) {
                    if (i < startIndex) {
                        break;
                    }
                }
                else if (i >= endIndex) {
                    break;
                }
                final Slot slot = this.inventorySlots.get(i);
                final ItemStack itemstack = slot.getStack();
                if (!itemstack.func_190926_b() && itemstack.getItem() == stack.getItem() && (!stack.getHasSubtypes() || stack.getMetadata() == itemstack.getMetadata()) && ItemStack.areItemStackTagsEqual(stack, itemstack)) {
                    final int j = itemstack.func_190916_E() + stack.func_190916_E();
                    if (j <= stack.getMaxStackSize()) {
                        stack.func_190920_e(0);
                        itemstack.func_190920_e(j);
                        slot.onSlotChanged();
                        flag = true;
                    }
                    else if (itemstack.func_190916_E() < stack.getMaxStackSize()) {
                        stack.func_190918_g(stack.getMaxStackSize() - itemstack.func_190916_E());
                        itemstack.func_190920_e(stack.getMaxStackSize());
                        slot.onSlotChanged();
                        flag = true;
                    }
                }
                if (reverseDirection) {
                    --i;
                }
                else {
                    ++i;
                }
            }
        }
        if (!stack.func_190926_b()) {
            if (reverseDirection) {
                i = endIndex - 1;
            }
            else {
                i = startIndex;
            }
            while (true) {
                if (reverseDirection) {
                    if (i < startIndex) {
                        break;
                    }
                }
                else if (i >= endIndex) {
                    break;
                }
                final Slot slot2 = this.inventorySlots.get(i);
                final ItemStack itemstack2 = slot2.getStack();
                if (itemstack2.func_190926_b() && slot2.isItemValid(stack)) {
                    if (stack.func_190916_E() > slot2.getSlotStackLimit()) {
                        slot2.putStack(stack.splitStack(slot2.getSlotStackLimit()));
                    }
                    else {
                        slot2.putStack(stack.splitStack(stack.func_190916_E()));
                    }
                    slot2.onSlotChanged();
                    flag = true;
                    break;
                }
                if (reverseDirection) {
                    --i;
                }
                else {
                    ++i;
                }
            }
        }
        return flag;
    }
    
    public static int extractDragMode(final int eventButton) {
        return eventButton >> 2 & 0x3;
    }
    
    public static int getDragEvent(final int clickedButton) {
        return clickedButton & 0x3;
    }
    
    public static int getQuickcraftMask(final int p_94534_0_, final int p_94534_1_) {
        return (p_94534_0_ & 0x3) | (p_94534_1_ & 0x3) << 2;
    }
    
    public static boolean isValidDragMode(final int dragModeIn, final EntityPlayer player) {
        return dragModeIn == 0 || dragModeIn == 1 || (dragModeIn == 2 && player.capabilities.isCreativeMode);
    }
    
    protected void resetDrag() {
        this.dragEvent = 0;
        this.dragSlots.clear();
    }
    
    public static boolean canAddItemToSlot(@Nullable final Slot slotIn, final ItemStack stack, final boolean stackSizeMatters) {
        final boolean flag = slotIn == null || !slotIn.getHasStack();
        return (!flag && stack.isItemEqual(slotIn.getStack()) && ItemStack.areItemStackTagsEqual(slotIn.getStack(), stack)) ? (slotIn.getStack().func_190916_E() + (stackSizeMatters ? 0 : stack.func_190916_E()) <= stack.getMaxStackSize()) : flag;
    }
    
    public static void computeStackSize(final Set<Slot> dragSlotsIn, final int dragModeIn, final ItemStack stack, final int slotStackSize) {
        switch (dragModeIn) {
            case 0: {
                stack.func_190920_e(MathHelper.floor(stack.func_190916_E() / (float)dragSlotsIn.size()));
                break;
            }
            case 1: {
                stack.func_190920_e(1);
                break;
            }
            case 2: {
                stack.func_190920_e(stack.getItem().getItemStackLimit());
                break;
            }
        }
        stack.func_190917_f(slotStackSize);
    }
    
    public boolean canDragIntoSlot(final Slot slotIn) {
        return true;
    }
    
    public static int calcRedstone(@Nullable final TileEntity te) {
        return (te instanceof IInventory) ? calcRedstoneFromInventory((IInventory)te) : 0;
    }
    
    public static int calcRedstoneFromInventory(@Nullable final IInventory inv) {
        if (inv == null) {
            return 0;
        }
        int i = 0;
        float f = 0.0f;
        for (int j = 0; j < inv.getSizeInventory(); ++j) {
            final ItemStack itemstack = inv.getStackInSlot(j);
            if (!itemstack.func_190926_b()) {
                f += itemstack.func_190916_E() / (float)Math.min(inv.getInventoryStackLimit(), itemstack.getMaxStackSize());
                ++i;
            }
        }
        f /= inv.getSizeInventory();
        return MathHelper.floor(f * 14.0f) + ((i > 0) ? 1 : 0);
    }
}
