// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.inventory;

import net.minecraft.util.NonNullList;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.ItemSword;
import net.minecraft.init.Items;
import net.minecraft.item.ItemHoe;
import net.minecraft.item.ItemPickaxe;
import net.minecraft.stats.StatBase;
import net.minecraft.stats.AchievementList;
import net.minecraft.item.Item;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.player.EntityPlayer;

public class SlotCrafting extends Slot
{
    private final InventoryCrafting craftMatrix;
    private final EntityPlayer thePlayer;
    private int amountCrafted;
    
    public SlotCrafting(final EntityPlayer player, final InventoryCrafting craftingInventory, final IInventory inventoryIn, final int slotIndex, final int xPosition, final int yPosition) {
        super(inventoryIn, slotIndex, xPosition, yPosition);
        this.thePlayer = player;
        this.craftMatrix = craftingInventory;
    }
    
    @Override
    public boolean isItemValid(final ItemStack stack) {
        return false;
    }
    
    @Override
    public ItemStack decrStackSize(final int amount) {
        if (this.getHasStack()) {
            this.amountCrafted += Math.min(amount, this.getStack().func_190916_E());
        }
        return super.decrStackSize(amount);
    }
    
    @Override
    protected void onCrafting(final ItemStack stack, final int amount) {
        this.amountCrafted += amount;
        this.onCrafting(stack);
    }
    
    @Override
    protected void func_190900_b(final int p_190900_1_) {
        this.amountCrafted += p_190900_1_;
    }
    
    @Override
    protected void onCrafting(final ItemStack stack) {
        if (this.amountCrafted > 0) {
            stack.onCrafting(this.thePlayer.world, this.thePlayer, this.amountCrafted);
        }
        this.amountCrafted = 0;
        if (stack.getItem() == Item.getItemFromBlock(Blocks.CRAFTING_TABLE)) {
            this.thePlayer.addStat(AchievementList.BUILD_WORK_BENCH);
        }
        if (stack.getItem() instanceof ItemPickaxe) {
            this.thePlayer.addStat(AchievementList.BUILD_PICKAXE);
        }
        if (stack.getItem() == Item.getItemFromBlock(Blocks.FURNACE)) {
            this.thePlayer.addStat(AchievementList.BUILD_FURNACE);
        }
        if (stack.getItem() instanceof ItemHoe) {
            this.thePlayer.addStat(AchievementList.BUILD_HOE);
        }
        if (stack.getItem() == Items.BREAD) {
            this.thePlayer.addStat(AchievementList.MAKE_BREAD);
        }
        if (stack.getItem() == Items.CAKE) {
            this.thePlayer.addStat(AchievementList.BAKE_CAKE);
        }
        if (stack.getItem() instanceof ItemPickaxe && ((ItemPickaxe)stack.getItem()).getToolMaterial() != Item.ToolMaterial.WOOD) {
            this.thePlayer.addStat(AchievementList.BUILD_BETTER_PICKAXE);
        }
        if (stack.getItem() instanceof ItemSword) {
            this.thePlayer.addStat(AchievementList.BUILD_SWORD);
        }
        if (stack.getItem() == Item.getItemFromBlock(Blocks.ENCHANTING_TABLE)) {
            this.thePlayer.addStat(AchievementList.ENCHANTMENTS);
        }
        if (stack.getItem() == Item.getItemFromBlock(Blocks.BOOKSHELF)) {
            this.thePlayer.addStat(AchievementList.BOOKCASE);
        }
    }
    
    @Override
    public ItemStack func_190901_a(final EntityPlayer p_190901_1_, final ItemStack p_190901_2_) {
        this.onCrafting(p_190901_2_);
        final NonNullList<ItemStack> nonnulllist = CraftingManager.getInstance().getRemainingItems(this.craftMatrix, p_190901_1_.world);
        for (int i = 0; i < nonnulllist.size(); ++i) {
            ItemStack itemstack = this.craftMatrix.getStackInSlot(i);
            final ItemStack itemstack2 = nonnulllist.get(i);
            if (!itemstack.func_190926_b()) {
                this.craftMatrix.decrStackSize(i, 1);
                itemstack = this.craftMatrix.getStackInSlot(i);
            }
            if (!itemstack2.func_190926_b()) {
                if (itemstack.func_190926_b()) {
                    this.craftMatrix.setInventorySlotContents(i, itemstack2);
                }
                else if (ItemStack.areItemsEqual(itemstack, itemstack2) && ItemStack.areItemStackTagsEqual(itemstack, itemstack2)) {
                    itemstack2.func_190917_f(itemstack.func_190916_E());
                    this.craftMatrix.setInventorySlotContents(i, itemstack2);
                }
                else if (!this.thePlayer.inventory.addItemStackToInventory(itemstack2)) {
                    this.thePlayer.dropItem(itemstack2, false);
                }
            }
        }
        return p_190901_2_;
    }
}
