// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.network.play.server;

import net.minecraft.network.INetHandler;
import java.io.IOException;
import net.minecraft.network.PacketBuffer;
import net.minecraft.world.BossInfo;
import net.minecraft.util.text.ITextComponent;
import java.util.UUID;
import net.minecraft.network.play.INetHandlerPlayClient;
import net.minecraft.network.Packet;

public class SPacketUpdateBossInfo implements Packet<INetHandlerPlayClient>
{
    private UUID uniqueId;
    private Operation operation;
    private ITextComponent name;
    private float percent;
    private BossInfo.Color color;
    private BossInfo.Overlay overlay;
    private boolean darkenSky;
    private boolean playEndBossMusic;
    private boolean createFog;
    
    public SPacketUpdateBossInfo() {
    }
    
    public SPacketUpdateBossInfo(final Operation operationIn, final BossInfo data) {
        this.operation = operationIn;
        this.uniqueId = data.getUniqueId();
        this.name = data.getName();
        this.percent = data.getPercent();
        this.color = data.getColor();
        this.overlay = data.getOverlay();
        this.darkenSky = data.shouldDarkenSky();
        this.playEndBossMusic = data.shouldPlayEndBossMusic();
        this.createFog = data.shouldCreateFog();
    }
    
    @Override
    public void readPacketData(final PacketBuffer buf) throws IOException {
        this.uniqueId = buf.readUuid();
        this.operation = buf.readEnumValue(Operation.class);
        switch (this.operation) {
            case ADD: {
                this.name = buf.readTextComponent();
                this.percent = buf.readFloat();
                this.color = buf.readEnumValue(BossInfo.Color.class);
                this.overlay = buf.readEnumValue(BossInfo.Overlay.class);
                this.setFlags(buf.readUnsignedByte());
                break;
            }
            case UPDATE_PCT: {
                this.percent = buf.readFloat();
                break;
            }
            case UPDATE_NAME: {
                this.name = buf.readTextComponent();
                break;
            }
            case UPDATE_STYLE: {
                this.color = buf.readEnumValue(BossInfo.Color.class);
                this.overlay = buf.readEnumValue(BossInfo.Overlay.class);
                break;
            }
            case UPDATE_PROPERTIES: {
                this.setFlags(buf.readUnsignedByte());
                break;
            }
        }
    }
    
    private void setFlags(final int flags) {
        this.darkenSky = ((flags & 0x1) > 0);
        this.playEndBossMusic = ((flags & 0x2) > 0);
        this.createFog = ((flags & 0x2) > 0);
    }
    
    @Override
    public void writePacketData(final PacketBuffer buf) throws IOException {
        buf.writeUuid(this.uniqueId);
        buf.writeEnumValue(this.operation);
        switch (this.operation) {
            case ADD: {
                buf.writeTextComponent(this.name);
                buf.writeFloat(this.percent);
                buf.writeEnumValue(this.color);
                buf.writeEnumValue(this.overlay);
                buf.writeByte(this.getFlags());
                break;
            }
            case UPDATE_PCT: {
                buf.writeFloat(this.percent);
                break;
            }
            case UPDATE_NAME: {
                buf.writeTextComponent(this.name);
                break;
            }
            case UPDATE_STYLE: {
                buf.writeEnumValue(this.color);
                buf.writeEnumValue(this.overlay);
                break;
            }
            case UPDATE_PROPERTIES: {
                buf.writeByte(this.getFlags());
                break;
            }
        }
    }
    
    private int getFlags() {
        int i = 0;
        if (this.darkenSky) {
            i |= 0x1;
        }
        if (this.playEndBossMusic) {
            i |= 0x2;
        }
        if (this.createFog) {
            i |= 0x2;
        }
        return i;
    }
    
    @Override
    public void processPacket(final INetHandlerPlayClient handler) {
        handler.handleUpdateEntityNBT(this);
    }
    
    public UUID getUniqueId() {
        return this.uniqueId;
    }
    
    public Operation getOperation() {
        return this.operation;
    }
    
    public ITextComponent getName() {
        return this.name;
    }
    
    public float getPercent() {
        return this.percent;
    }
    
    public BossInfo.Color getColor() {
        return this.color;
    }
    
    public BossInfo.Overlay getOverlay() {
        return this.overlay;
    }
    
    public boolean shouldDarkenSky() {
        return this.darkenSky;
    }
    
    public boolean shouldPlayEndBossMusic() {
        return this.playEndBossMusic;
    }
    
    public boolean shouldCreateFog() {
        return this.createFog;
    }
    
    public enum Operation
    {
        ADD("ADD", 0), 
        REMOVE("REMOVE", 1), 
        UPDATE_PCT("UPDATE_PCT", 2), 
        UPDATE_NAME("UPDATE_NAME", 3), 
        UPDATE_STYLE("UPDATE_STYLE", 4), 
        UPDATE_PROPERTIES("UPDATE_PROPERTIES", 5);
        
        private Operation(final String name, final int ordinal) {
        }
    }
}
