// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.potion;

import net.minecraft.item.ItemPotion;
import net.minecraft.init.PotionTypes;
import net.minecraft.item.ItemFishFood;
import net.minecraft.init.Items;
import java.util.Iterator;
import com.google.common.collect.Lists;
import net.minecraft.item.ItemStack;
import com.google.common.base.Predicate;
import net.minecraft.item.Item;
import java.util.List;

public class PotionHelper
{
    private static final List<MixPredicate<PotionType>> POTION_TYPE_CONVERSIONS;
    private static final List<MixPredicate<Item>> POTION_ITEM_CONVERSIONS;
    private static final List<ItemPredicateInstance> POTION_ITEMS;
    private static final Predicate<ItemStack> IS_POTION_ITEM;
    
    static {
        POTION_TYPE_CONVERSIONS = Lists.newArrayList();
        POTION_ITEM_CONVERSIONS = Lists.newArrayList();
        POTION_ITEMS = Lists.newArrayList();
        IS_POTION_ITEM = (Predicate)new Predicate<ItemStack>() {
            public boolean apply(final ItemStack p_apply_1_) {
                for (final ItemPredicateInstance potionhelper$itempredicateinstance : PotionHelper.POTION_ITEMS) {
                    if (potionhelper$itempredicateinstance.apply(p_apply_1_)) {
                        return true;
                    }
                }
                return false;
            }
        };
    }
    
    public static boolean isReagent(final ItemStack stack) {
        return isItemConversionReagent(stack) || isTypeConversionReagent(stack);
    }
    
    protected static boolean isItemConversionReagent(final ItemStack stack) {
        for (int i = 0, j = PotionHelper.POTION_ITEM_CONVERSIONS.size(); i < j; ++i) {
            if (PotionHelper.POTION_ITEM_CONVERSIONS.get(i).reagent.apply((Object)stack)) {
                return true;
            }
        }
        return false;
    }
    
    protected static boolean isTypeConversionReagent(final ItemStack stack) {
        for (int i = 0, j = PotionHelper.POTION_TYPE_CONVERSIONS.size(); i < j; ++i) {
            if (PotionHelper.POTION_TYPE_CONVERSIONS.get(i).reagent.apply((Object)stack)) {
                return true;
            }
        }
        return false;
    }
    
    public static boolean hasConversions(final ItemStack input, final ItemStack reagent) {
        return PotionHelper.IS_POTION_ITEM.apply((Object)input) && (hasItemConversions(input, reagent) || hasTypeConversions(input, reagent));
    }
    
    protected static boolean hasItemConversions(final ItemStack p_185206_0_, final ItemStack p_185206_1_) {
        final Item item = p_185206_0_.getItem();
        for (int i = 0, j = PotionHelper.POTION_ITEM_CONVERSIONS.size(); i < j; ++i) {
            final MixPredicate<Item> mixpredicate = PotionHelper.POTION_ITEM_CONVERSIONS.get(i);
            if (mixpredicate.input == item && mixpredicate.reagent.apply((Object)p_185206_1_)) {
                return true;
            }
        }
        return false;
    }
    
    protected static boolean hasTypeConversions(final ItemStack p_185209_0_, final ItemStack p_185209_1_) {
        final PotionType potiontype = PotionUtils.getPotionFromItem(p_185209_0_);
        for (int i = 0, j = PotionHelper.POTION_TYPE_CONVERSIONS.size(); i < j; ++i) {
            final MixPredicate<PotionType> mixpredicate = PotionHelper.POTION_TYPE_CONVERSIONS.get(i);
            if (mixpredicate.input == potiontype && mixpredicate.reagent.apply((Object)p_185209_1_)) {
                return true;
            }
        }
        return false;
    }
    
    public static ItemStack doReaction(final ItemStack reagent, final ItemStack potionIn) {
        if (!potionIn.func_190926_b()) {
            final PotionType potiontype = PotionUtils.getPotionFromItem(potionIn);
            final Item item = potionIn.getItem();
            for (int i = 0, j = PotionHelper.POTION_ITEM_CONVERSIONS.size(); i < j; ++i) {
                final MixPredicate<Item> mixpredicate = PotionHelper.POTION_ITEM_CONVERSIONS.get(i);
                if (mixpredicate.input == item && mixpredicate.reagent.apply((Object)reagent)) {
                    return PotionUtils.addPotionToItemStack(new ItemStack(mixpredicate.output), potiontype);
                }
            }
            for (int i = 0, k = PotionHelper.POTION_TYPE_CONVERSIONS.size(); i < k; ++i) {
                final MixPredicate<PotionType> mixpredicate2 = PotionHelper.POTION_TYPE_CONVERSIONS.get(i);
                if (mixpredicate2.input == potiontype && mixpredicate2.reagent.apply((Object)reagent)) {
                    return PotionUtils.addPotionToItemStack(new ItemStack(item), mixpredicate2.output);
                }
            }
        }
        return potionIn;
    }
    
    public static void init() {
        final Predicate<ItemStack> predicate = (Predicate<ItemStack>)new ItemPredicateInstance(Items.NETHER_WART);
        final Predicate<ItemStack> predicate2 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.GOLDEN_CARROT);
        final Predicate<ItemStack> predicate3 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.REDSTONE);
        final Predicate<ItemStack> predicate4 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.FERMENTED_SPIDER_EYE);
        final Predicate<ItemStack> predicate5 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.RABBIT_FOOT);
        final Predicate<ItemStack> predicate6 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.GLOWSTONE_DUST);
        final Predicate<ItemStack> predicate7 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.MAGMA_CREAM);
        final Predicate<ItemStack> predicate8 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.SUGAR);
        final Predicate<ItemStack> predicate9 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.FISH, ItemFishFood.FishType.PUFFERFISH.getMetadata());
        final Predicate<ItemStack> predicate10 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.SPECKLED_MELON);
        final Predicate<ItemStack> predicate11 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.SPIDER_EYE);
        final Predicate<ItemStack> predicate12 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.GHAST_TEAR);
        final Predicate<ItemStack> predicate13 = (Predicate<ItemStack>)new ItemPredicateInstance(Items.BLAZE_POWDER);
        registerPotionItem(new ItemPredicateInstance(Items.POTIONITEM));
        registerPotionItem(new ItemPredicateInstance(Items.SPLASH_POTION));
        registerPotionItem(new ItemPredicateInstance(Items.LINGERING_POTION));
        registerPotionItemConversion(Items.POTIONITEM, new ItemPredicateInstance(Items.GUNPOWDER), Items.SPLASH_POTION);
        registerPotionItemConversion(Items.SPLASH_POTION, new ItemPredicateInstance(Items.DRAGON_BREATH), Items.LINGERING_POTION);
        registerPotionTypeConversion(PotionTypes.WATER, predicate10, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate12, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate5, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate13, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate11, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate8, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate7, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate6, PotionTypes.THICK);
        registerPotionTypeConversion(PotionTypes.WATER, predicate3, PotionTypes.MUNDANE);
        registerPotionTypeConversion(PotionTypes.WATER, predicate, PotionTypes.AWKWARD);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate2, PotionTypes.NIGHT_VISION);
        registerPotionTypeConversion(PotionTypes.NIGHT_VISION, predicate3, PotionTypes.LONG_NIGHT_VISION);
        registerPotionTypeConversion(PotionTypes.NIGHT_VISION, predicate4, PotionTypes.INVISIBILITY);
        registerPotionTypeConversion(PotionTypes.LONG_NIGHT_VISION, predicate4, PotionTypes.LONG_INVISIBILITY);
        registerPotionTypeConversion(PotionTypes.INVISIBILITY, predicate3, PotionTypes.LONG_INVISIBILITY);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate7, PotionTypes.FIRE_RESISTANCE);
        registerPotionTypeConversion(PotionTypes.FIRE_RESISTANCE, predicate3, PotionTypes.LONG_FIRE_RESISTANCE);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate5, PotionTypes.LEAPING);
        registerPotionTypeConversion(PotionTypes.LEAPING, predicate3, PotionTypes.LONG_LEAPING);
        registerPotionTypeConversion(PotionTypes.LEAPING, predicate6, PotionTypes.STRONG_LEAPING);
        registerPotionTypeConversion(PotionTypes.LEAPING, predicate4, PotionTypes.SLOWNESS);
        registerPotionTypeConversion(PotionTypes.LONG_LEAPING, predicate4, PotionTypes.LONG_SLOWNESS);
        registerPotionTypeConversion(PotionTypes.SLOWNESS, predicate3, PotionTypes.LONG_SLOWNESS);
        registerPotionTypeConversion(PotionTypes.SWIFTNESS, predicate4, PotionTypes.SLOWNESS);
        registerPotionTypeConversion(PotionTypes.LONG_SWIFTNESS, predicate4, PotionTypes.LONG_SLOWNESS);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate8, PotionTypes.SWIFTNESS);
        registerPotionTypeConversion(PotionTypes.SWIFTNESS, predicate3, PotionTypes.LONG_SWIFTNESS);
        registerPotionTypeConversion(PotionTypes.SWIFTNESS, predicate6, PotionTypes.STRONG_SWIFTNESS);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate9, PotionTypes.WATER_BREATHING);
        registerPotionTypeConversion(PotionTypes.WATER_BREATHING, predicate3, PotionTypes.LONG_WATER_BREATHING);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate10, PotionTypes.HEALING);
        registerPotionTypeConversion(PotionTypes.HEALING, predicate6, PotionTypes.STRONG_HEALING);
        registerPotionTypeConversion(PotionTypes.HEALING, predicate4, PotionTypes.HARMING);
        registerPotionTypeConversion(PotionTypes.STRONG_HEALING, predicate4, PotionTypes.STRONG_HARMING);
        registerPotionTypeConversion(PotionTypes.HARMING, predicate6, PotionTypes.STRONG_HARMING);
        registerPotionTypeConversion(PotionTypes.POISON, predicate4, PotionTypes.HARMING);
        registerPotionTypeConversion(PotionTypes.LONG_POISON, predicate4, PotionTypes.HARMING);
        registerPotionTypeConversion(PotionTypes.STRONG_POISON, predicate4, PotionTypes.STRONG_HARMING);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate11, PotionTypes.POISON);
        registerPotionTypeConversion(PotionTypes.POISON, predicate3, PotionTypes.LONG_POISON);
        registerPotionTypeConversion(PotionTypes.POISON, predicate6, PotionTypes.STRONG_POISON);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate12, PotionTypes.REGENERATION);
        registerPotionTypeConversion(PotionTypes.REGENERATION, predicate3, PotionTypes.LONG_REGENERATION);
        registerPotionTypeConversion(PotionTypes.REGENERATION, predicate6, PotionTypes.STRONG_REGENERATION);
        registerPotionTypeConversion(PotionTypes.AWKWARD, predicate13, PotionTypes.STRENGTH);
        registerPotionTypeConversion(PotionTypes.STRENGTH, predicate3, PotionTypes.LONG_STRENGTH);
        registerPotionTypeConversion(PotionTypes.STRENGTH, predicate6, PotionTypes.STRONG_STRENGTH);
        registerPotionTypeConversion(PotionTypes.WATER, predicate4, PotionTypes.WEAKNESS);
        registerPotionTypeConversion(PotionTypes.WEAKNESS, predicate3, PotionTypes.LONG_WEAKNESS);
    }
    
    private static void registerPotionItemConversion(final ItemPotion p_185201_0_, final ItemPredicateInstance p_185201_1_, final ItemPotion p_185201_2_) {
        PotionHelper.POTION_ITEM_CONVERSIONS.add(new MixPredicate<Item>(p_185201_0_, (Predicate<ItemStack>)p_185201_1_, p_185201_2_));
    }
    
    private static void registerPotionItem(final ItemPredicateInstance p_185202_0_) {
        PotionHelper.POTION_ITEMS.add(p_185202_0_);
    }
    
    private static void registerPotionTypeConversion(final PotionType input, final Predicate<ItemStack> reagentPredicate, final PotionType output) {
        PotionHelper.POTION_TYPE_CONVERSIONS.add(new MixPredicate<PotionType>(input, reagentPredicate, output));
    }
    
    static class ItemPredicateInstance implements Predicate<ItemStack>
    {
        private final Item item;
        private final int meta;
        
        public ItemPredicateInstance(final Item itemIn) {
            this(itemIn, -1);
        }
        
        public ItemPredicateInstance(final Item itemIn, final int metaIn) {
            this.item = itemIn;
            this.meta = metaIn;
        }
        
        public boolean apply(final ItemStack p_apply_1_) {
            return p_apply_1_.getItem() == this.item && (this.meta == -1 || this.meta == p_apply_1_.getMetadata());
        }
    }
    
    static class MixPredicate<T>
    {
        final T input;
        final Predicate<ItemStack> reagent;
        final T output;
        
        public MixPredicate(final T inputIn, final Predicate<ItemStack> reagentIn, final T outputIn) {
            this.input = inputIn;
            this.reagent = reagentIn;
            this.output = outputIn;
        }
    }
}
