// 
// Decompiled by Procyon v0.5.36
// 

package net.minecraft.stats;

import net.minecraft.util.IJsonSerializable;
import net.minecraft.util.JsonSerializableSet;
import net.minecraft.block.Block;
import net.minecraft.potion.PotionUtils;
import net.minecraft.init.PotionTypes;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import com.google.common.collect.Lists;
import java.util.List;

public class AchievementList
{
    public static int minDisplayColumn;
    public static int minDisplayRow;
    public static int maxDisplayColumn;
    public static int maxDisplayRow;
    public static final List<Achievement> ACHIEVEMENTS;
    public static final Achievement OPEN_INVENTORY;
    public static final Achievement MINE_WOOD;
    public static final Achievement BUILD_WORK_BENCH;
    public static final Achievement BUILD_PICKAXE;
    public static final Achievement BUILD_FURNACE;
    public static final Achievement ACQUIRE_IRON;
    public static final Achievement BUILD_HOE;
    public static final Achievement MAKE_BREAD;
    public static final Achievement BAKE_CAKE;
    public static final Achievement BUILD_BETTER_PICKAXE;
    public static final Achievement COOK_FISH;
    public static final Achievement ON_A_RAIL;
    public static final Achievement BUILD_SWORD;
    public static final Achievement KILL_ENEMY;
    public static final Achievement KILL_COW;
    public static final Achievement FLY_PIG;
    public static final Achievement SNIPE_SKELETON;
    public static final Achievement DIAMONDS;
    public static final Achievement DIAMONDS_TO_YOU;
    public static final Achievement PORTAL;
    public static final Achievement GHAST;
    public static final Achievement BLAZE_ROD;
    public static final Achievement POTION;
    public static final Achievement THE_END;
    public static final Achievement THE_END2;
    public static final Achievement ENCHANTMENTS;
    public static final Achievement OVERKILL;
    public static final Achievement BOOKCASE;
    public static final Achievement BREED_COW;
    public static final Achievement SPAWN_WITHER;
    public static final Achievement KILL_WITHER;
    public static final Achievement FULL_BEACON;
    public static final Achievement EXPLORE_ALL_BIOMES;
    public static final Achievement OVERPOWERED;
    
    static {
        ACHIEVEMENTS = Lists.newArrayList();
        OPEN_INVENTORY = new Achievement("achievement.openInventory", "openInventory", 0, 0, Items.BOOK, null).initIndependentStat().registerStat();
        MINE_WOOD = new Achievement("achievement.mineWood", "mineWood", 2, 1, Blocks.LOG, AchievementList.OPEN_INVENTORY).registerStat();
        BUILD_WORK_BENCH = new Achievement("achievement.buildWorkBench", "buildWorkBench", 4, -1, Blocks.CRAFTING_TABLE, AchievementList.MINE_WOOD).registerStat();
        BUILD_PICKAXE = new Achievement("achievement.buildPickaxe", "buildPickaxe", 4, 2, Items.WOODEN_PICKAXE, AchievementList.BUILD_WORK_BENCH).registerStat();
        BUILD_FURNACE = new Achievement("achievement.buildFurnace", "buildFurnace", 3, 4, Blocks.FURNACE, AchievementList.BUILD_PICKAXE).registerStat();
        ACQUIRE_IRON = new Achievement("achievement.acquireIron", "acquireIron", 1, 4, Items.IRON_INGOT, AchievementList.BUILD_FURNACE).registerStat();
        BUILD_HOE = new Achievement("achievement.buildHoe", "buildHoe", 2, -3, Items.WOODEN_HOE, AchievementList.BUILD_WORK_BENCH).registerStat();
        MAKE_BREAD = new Achievement("achievement.makeBread", "makeBread", -1, -3, Items.BREAD, AchievementList.BUILD_HOE).registerStat();
        BAKE_CAKE = new Achievement("achievement.bakeCake", "bakeCake", 0, -5, Items.CAKE, AchievementList.BUILD_HOE).registerStat();
        BUILD_BETTER_PICKAXE = new Achievement("achievement.buildBetterPickaxe", "buildBetterPickaxe", 6, 2, Items.STONE_PICKAXE, AchievementList.BUILD_PICKAXE).registerStat();
        COOK_FISH = new Achievement("achievement.cookFish", "cookFish", 2, 6, Items.COOKED_FISH, AchievementList.BUILD_FURNACE).registerStat();
        ON_A_RAIL = new Achievement("achievement.onARail", "onARail", 2, 3, Blocks.RAIL, AchievementList.ACQUIRE_IRON).setSpecial().registerStat();
        BUILD_SWORD = new Achievement("achievement.buildSword", "buildSword", 6, -1, Items.WOODEN_SWORD, AchievementList.BUILD_WORK_BENCH).registerStat();
        KILL_ENEMY = new Achievement("achievement.killEnemy", "killEnemy", 8, -1, Items.BONE, AchievementList.BUILD_SWORD).registerStat();
        KILL_COW = new Achievement("achievement.killCow", "killCow", 7, -3, Items.LEATHER, AchievementList.BUILD_SWORD).registerStat();
        FLY_PIG = new Achievement("achievement.flyPig", "flyPig", 9, -3, Items.SADDLE, AchievementList.KILL_COW).setSpecial().registerStat();
        SNIPE_SKELETON = new Achievement("achievement.snipeSkeleton", "snipeSkeleton", 7, 0, Items.BOW, AchievementList.KILL_ENEMY).setSpecial().registerStat();
        DIAMONDS = new Achievement("achievement.diamonds", "diamonds", -1, 5, Blocks.DIAMOND_ORE, AchievementList.ACQUIRE_IRON).registerStat();
        DIAMONDS_TO_YOU = new Achievement("achievement.diamondsToYou", "diamondsToYou", -1, 2, Items.DIAMOND, AchievementList.DIAMONDS).registerStat();
        PORTAL = new Achievement("achievement.portal", "portal", -1, 7, Blocks.OBSIDIAN, AchievementList.DIAMONDS).registerStat();
        GHAST = new Achievement("achievement.ghast", "ghast", -4, 8, Items.GHAST_TEAR, AchievementList.PORTAL).setSpecial().registerStat();
        BLAZE_ROD = new Achievement("achievement.blazeRod", "blazeRod", 0, 9, Items.BLAZE_ROD, AchievementList.PORTAL).registerStat();
        POTION = new Achievement("achievement.potion", "potion", 2, 8, PotionUtils.addPotionToItemStack(new ItemStack(Items.POTIONITEM), PotionTypes.REGENERATION), AchievementList.BLAZE_ROD).registerStat();
        THE_END = new Achievement("achievement.theEnd", "theEnd", 3, 10, Items.ENDER_EYE, AchievementList.BLAZE_ROD).setSpecial().registerStat();
        THE_END2 = new Achievement("achievement.theEnd2", "theEnd2", 4, 13, Blocks.DRAGON_EGG, AchievementList.THE_END).setSpecial().registerStat();
        ENCHANTMENTS = new Achievement("achievement.enchantments", "enchantments", -4, 4, Blocks.ENCHANTING_TABLE, AchievementList.DIAMONDS).registerStat();
        OVERKILL = new Achievement("achievement.overkill", "overkill", -4, 1, Items.DIAMOND_SWORD, AchievementList.ENCHANTMENTS).setSpecial().registerStat();
        BOOKCASE = new Achievement("achievement.bookcase", "bookcase", -3, 6, Blocks.BOOKSHELF, AchievementList.ENCHANTMENTS).registerStat();
        BREED_COW = new Achievement("achievement.breedCow", "breedCow", 7, -5, Items.WHEAT, AchievementList.KILL_COW).registerStat();
        SPAWN_WITHER = new Achievement("achievement.spawnWither", "spawnWither", 7, 12, new ItemStack(Items.SKULL, 1, 1), AchievementList.THE_END2).registerStat();
        KILL_WITHER = new Achievement("achievement.killWither", "killWither", 7, 10, Items.NETHER_STAR, AchievementList.SPAWN_WITHER).registerStat();
        FULL_BEACON = new Achievement("achievement.fullBeacon", "fullBeacon", 7, 8, Blocks.BEACON, AchievementList.KILL_WITHER).setSpecial().registerStat();
        EXPLORE_ALL_BIOMES = new Achievement("achievement.exploreAllBiomes", "exploreAllBiomes", 4, 8, Items.DIAMOND_BOOTS, AchievementList.THE_END).setSerializableClazz(JsonSerializableSet.class).setSpecial().registerStat();
        OVERPOWERED = new Achievement("achievement.overpowered", "overpowered", 6, 4, new ItemStack(Items.GOLDEN_APPLE, 1, 1), AchievementList.BUILD_BETTER_PICKAXE).setSpecial().registerStat();
    }
    
    public static void init() {
    }
}
